angular.module('gracenote.controllers', ['ionic', 'ngCordova'])

.config(function($ionicConfigProvider) {
    //$ionicConfigProvider.views.maxCache(5);
    $ionicConfigProvider.tabs.style('ios'); //even if you're on android
    $ionicConfigProvider.tabs.position('ios'); //even if you're on android
      // note that you can also chain configs
    //$ionicConfigProvider.backButton.text('Go Back').icon('ion-chevron-left');
    $ionicConfigProvider.navBar.alignTitle('center');
    //$ionicConfigProvider.views.maxCache(2);
    //$ionicConfigProvider.views.transition('none');
})

.controller('NoteFeedCtrl', function($scope, $stateParams, $http, $ionicHistory, $rootScope,
            $ionicLoading, $ionicScrollDelegate, $ionicModal, noteFactory, userFactory) {
    $scope.endofdata = false;
    $scope.notes = [];
    $scope.lastnoteid = 0;
    $scope.data = {reason: 'xx'};
            
    $scope.doRefresh = function() {
        console.log("Feed doRefresh");
        $scope.lastnoteid = 0;
        $scope.getNotes();
        $ionicScrollDelegate.scrollTop();
        $scope.$broadcast('scroll.refreshComplete');
     };
    
    $scope.makeNoteFavorite = function(note){
        if (note.favorite == 1) {
            note.favorite = 0;
            note.favorites = +note.favorites - 1;
            noteFactory.deleteNoteFavorite(note.id,$scope.user.id).then(function(response) {
                $rootScope.$broadcast('refreshFav');
            });
        } else {
            note.favorite = 1;
            note.favorites = +note.favorites + 1;
            noteFactory.insertNoteFavorite(note.id,$scope.user.id,note.fid,$scope.user.name,
                  $rootScope.escapeHTML(note.descr).substring(0,30)).then(function(response) {
                $rootScope.$broadcast('refreshFav');
            });
        }
    }

    $scope.makeNoteAmen = function(note){
        if (note.amen == 1) {
            note.amen = 0;
            note.amens = +note.amens - 1;
            noteFactory.deleteNoteAmen(note.id,$scope.user.id).then(function(response) {
            });
        } else {
            note.amen = 1;
            note.amens = +note.amens + 1;
            noteFactory.insertNoteAmen(note.id,$scope.user.id,note.fid,$scope.user.name,
                                           note.descr).then(function(response) {
            });
        }
    }

    $scope.getNotes = function() {
        noteFactory.getFeedNotes($scope.user.fid, $scope.lastnoteid)
            .then(function(response) {
                $scope.notes = noteFactory.getFeedNotesCache();
                (response.data.length < 10) ?  $scope.endofdata = true : $scope.endofdata = false;                  
                if (response.data.length > 0) $scope.lastnoteid = response.data[response.data.length-1].id;
                $scope.$broadcast('scroll.refreshComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
    }

    $scope.openReport = function (note) {
         $ionicModal.fromTemplateUrl('templates/report.html', {
           scope: $scope
         })
         .then(function(modal) {
            $scope.noteid = note.id;
            $scope.notefid = note.fid;
            $scope.notename = note.name;
            $scope.modal = modal;
            $scope.modal.show();
         });
    }

    $scope.closeModal = function() {
        $scope.modal.hide();
        resetModal();
    };

    $scope.reportObjectionable = function(){
        noteFactory.reportObjectionable($scope.noteid,$scope.user.fid, $scope.data.reason).then(function(response) {
            $rootScope.$broadcast("refreshFeed");
            $rootScope.$broadcast("refreshFav");
            $rootScope.$broadcast("refreshSearch");
            $scope.modal.hide();
            resetModal();
        });
    }

    $scope.unFollow = function(){
        userFactory.unFollow($scope.user.id,$scope.notefid).then(function(response) {
            $rootScope.$broadcast("refreshFeed");
            $rootScope.$broadcast("refreshFav");
            $rootScope.$broadcast("refreshSearch");
            $rootScope.$broadcast("refreshUser");
            $scope.modal.hide();
            resetModal();
        });
    }

    function resetModal() {
        $scope.noteid = 0;
        $scope.notefid = 0;
        $scope.notename = '';
        $scope.modal.remove();
        $scope.data.reason = "xx";          
    }

    $rootScope.$on('refreshFeed', function (event, args) {
        $scope.doRefresh();
        console.log("got refreshFeed. calling doRefresh");
    });
    
    
    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("before enter");
        $scope.user = $rootScope.user;
        $rootScope.tab = "feed";
        $scope.tab = $rootScope.tab;
        $scope.notes = noteFactory.getFeedNotesCache();
    });
})

.controller('NoteViewCtrl', function($scope, $stateParams, $http, $ionicHistory, $rootScope,
                            $ionicModal, $ionicLoading, noteFactory, userFactory) {
    //console.log("NoteViewCtrl");
    $scope.data = {reason: 'xx'};
    

    $scope.makeNoteFavorite = function(note){
        if (note.favorite == 1) {
            note.favorite = 0;
            note.favorites = +note.favorites - 1;
            noteFactory.deleteNoteFavorite(note.id,$scope.user.id).then(function(response) {
                $rootScope.$broadcast('refreshFav');
            });
        } else {
            note.favorite = 1;
            note.favorites = +note.favorites + 1;
            noteFactory.insertNoteFavorite(note.id,$scope.user.id,note.fid,$scope.user.name,
                  $rootScope.escapeHTML(note.descr).substring(0,30)).then(function(response) {
                $rootScope.$broadcast('refreshFav');
            });
        }
    }

    $scope.makeNoteAmen = function(note){
        if (note.amen == 1) {
            note.amen = 0;
            note.amens = +note.amens - 1;
            noteFactory.deleteNoteAmen(note.id,$scope.user.id).then(function(response) {
            });
        } else {
            note.amen = 1;
            note.amens = +note.amens + 1;
            noteFactory.insertNoteAmen(note.id,$scope.user.id,note.fid,$scope.user.name,
                                           note.descr).then(function(response) {
            });
        }
    }

    function getNote() {
        if ($scope.tab == 'feed') {
            $scope.note = noteFactory.getFeedNote($stateParams.noteid);
            if ($scope.note != null) {
                noteFactory.getFeedComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;    
                });
            } else {
                noteFactory.getNote($stateParams.noteid, $scope.user.fid).then(function(response) {
                    $scope.note = response.data[0];
                });
                noteFactory.getComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;
                    
                });
            }
        } else
        if ($scope.tab == 'search') {
            $scope.note = noteFactory.getSearchNote($stateParams.noteid);
            if ($scope.note != null) {
                noteFactory.getSearchComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;    
                });
            } else {
                noteFactory.getNote($stateParams.noteid, $scope.user.fid).then(function(response) {
                    $scope.note = response.data[0];
                });
                noteFactory.getComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;
                });
            }
        } else
        if ($scope.tab == 'fav') {
            $scope.note = noteFactory.getFavoriteNote($stateParams.noteid);
            if ($scope.note != null) {
                noteFactory.getFavoriteComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;    
                });
            } else {
                noteFactory.getNote($stateParams.noteid, $scope.user.fid).then(function(response) {
                    $scope.note = response.data[0];
                });
                noteFactory.getComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;
                });
            }
        } else
        if ($scope.tab == 'event') {
              noteFactory.getNote($stateParams.noteid, $scope.user.fid).then(function(response) {
                  $scope.note = response.data[0];
              });
              noteFactory.getComments($stateParams.noteid).then(function(response) {
                  $scope.comments = response.data;
              });
        } else
        if ($scope.tab == 'wall') {
            $scope.note = noteFactory.getWallNote($stateParams.noteid);
            if ($scope.note != null) {
                noteFactory.getWallComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;    
                });
            } else {
                noteFactory.getNote($stateParams.noteid, $scope.user.fid).then(function(response) {
                    $scope.note = response.data[0];
                });
                noteFactory.getComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;
                });
            }
        }
        
    };

    $scope.openReport = function (note) {
         $ionicModal.fromTemplateUrl('templates/report.html', {
           scope: $scope
         })
         .then(function(modal) {
            $scope.noteid = note.id;
            $scope.notefid = note.fid;
            $scope.notename = note.name;
            $scope.modal = modal;
            $scope.modal.show();
         });
    }

    $scope.closeModal = function() {
        $scope.modal.hide();
        resetModal();
    };

    $scope.reportObjectionable = function(){
        noteFactory.reportObjectionable($scope.noteid,$scope.user.fid, $scope.data.reason).then(function(response) {
            $rootScope.$broadcast("refreshFeed");
            $rootScope.$broadcast("refreshFav");
            $rootScope.$broadcast("refreshSearch");
            $scope.modal.hide();
            resetModal();
        });
    }

    $scope.unFollow = function(){
        userFactory.unFollow($scope.user.id,$scope.notefid).then(function(response) {
            $rootScope.$broadcast("refreshFeed");
            $rootScope.$broadcast("refreshFav");
            $rootScope.$broadcast("refreshSearch");
            $rootScope.$broadcast("refreshUser");
            $scope.modal.hide();
            resetModal();
            $ionicHistory.goBack();                
        });
    }

    function resetModal() {
        $scope.noteid = 0;
        $scope.notefid = 0;
        $scope.notename = '';
        $scope.modal.remove();
        $scope.data.reason = "xx";          
    }

    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("NoteViewCtrl beforeEnter callback fired");
        $scope.user = $rootScope.user;
        $scope.tab = $rootScope.tab;
        getNote();
    });
})
    
.controller('NoteFavoriteCtrl', function($scope, $stateParams, $http, $rootScope, $ionicLoading,
                  $ionicModal, $ionicScrollDelegate, noteFactory, userFactory) {
    //console.log("NoteFavoriteCtrl");
    $scope.endofdata = false;
    $scope.notes = [];
    $scope.lastnoteid = 0;
    $scope.data = {reason: 'xx'};

    $scope.doRefresh = function() {
        $scope.lastnoteid = 0;
        $scope.getNotes();
        //$ionicScrollDelegate.scrollTop();
        //$scope.$broadcast('scroll.refreshComplete');
    }

    $scope.makeNoteFavorite = function(note){
        if (note.favorite == 1) {
            note.favorite = 0;
            note.favorites = +note.favorites - 1;
            noteFactory.deleteNoteFavorite(note.id,$scope.user.id).then(function(response) {
                var i = $scope.notes.length;
                while (i--) {
                    if ($scope.notes[i].id == note.id) {
                        //console.log("removing note=" + $scope.notes[i].id);
                        $scope.notes.splice(i,1);
                    }
                }
            });
        } else {
            note.favorite = 1;
            note.favorites = +note.favorites + 1;
            noteFactory.insertNoteFavorite(note.id,$scope.user.id,note.fid,$scope.user.name,
                  $rootScope.escapeHTML(note.descr).substring(0,30)).then(function(response) {
            });
        }
    }

    $scope.makeNoteAmen = function(note){
        if (note.amen == 1) {
            note.amen = 0;
            note.amens = +note.amens - 1;
            noteFactory.deleteNoteAmen(note.id,$scope.user.id).then(function(response) {
            });
        } else {
            note.amen = 1;
            note.amens = +note.amens + 1;
            noteFactory.insertNoteAmen(note.id,$scope.user.id,note.fid,$scope.user.name,
                                           note.descr).then(function(response) {
            });
        }
        $rootScope.$broadcast("refreshFeed");
    }

    $scope.getNotes = function() {
        noteFactory.getFavoriteNotes($scope.user.fid, $scope.lastnoteid)
            .then(function(response) {
                $scope.notes = noteFactory.getFavoriteNotesCache();
                (response.data.length < 10) ?  $scope.endofdata = true : $scope.endofdata = false;                  
                if (response.data.length > 0) $scope.lastnoteid = response.data[response.data.length-1].id;
                $scope.$broadcast('scroll.refreshComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
    }

    $scope.openReport = function (note) {
         $ionicModal.fromTemplateUrl('templates/report.html', {
           scope: $scope
         })
         .then(function(modal) {
            $scope.noteid = note.id;
            $scope.notefid = note.fid;
            $scope.notename = note.name;
            $scope.modal = modal;
            $scope.modal.show();
         });
    }

    $scope.closeModal = function() {
        $scope.modal.hide();
        resetModal();
    };

    $scope.reportObjectionable = function(){
        noteFactory.reportObjectionable($scope.noteid,$scope.user.fid, $scope.data.reason).then(function(response) {
            $rootScope.$broadcast("refreshFeed");
            $rootScope.$broadcast("refreshFav");
            $rootScope.$broadcast("refreshSearch");
            $scope.modal.hide();
            resetModal();
        });
    }

    $scope.unFollow = function(){
        userFactory.unFollow($scope.user.id,$scope.notefid).then(function(response) {
            $rootScope.$broadcast("refreshFeed");
            $rootScope.$broadcast("refreshFav");
            $rootScope.$broadcast("refreshSearch");
            $rootScope.$broadcast("refreshUser");
            $scope.modal.hide();
            resetModal();
        });
    }

    function resetModal() {
        $scope.noteid = 0;
        $scope.notefid = 0;
        $scope.notename = '';
        $scope.modal.remove();
        $scope.data.reason = "xx";          
    }

    $rootScope.$on('refreshFav', function (event, args) {
        $scope.doRefresh();
        console.log("got refreshFav. calling doRefresh");
    });

    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("NoteFavoriteCtrl beforeEnter callback fired");
        $scope.user = $rootScope.user;
        $rootScope.tab = "fav";
        $scope.tab = $rootScope.tab;
        $scope.notes = noteFactory.getFavoriteNotesCache();
    });
})

.controller('NoteWallCtrl', function($scope, $stateParams, $http, $ionicHistory, $rootScope,
              $ionicModal, $ionicLoading, $ionicScrollDelegate, userFactory, noteFactory) {
    //console.log("NoteWallCtrl");
    $scope.endofdata = false;
    $scope.notes = [];
    $scope.lastnoteid = 0;

    $scope.bannerpicnum = 0;
    $scope.bannerpicCamera = 0;
    $scope.bannerpicLibrary = 0;
    $scope.bannerpicture = null;
    $scope.avatarpicnum = 0;
    $scope.avatarpicCamera = 0;
    $scope.avatarpicLibrary = 0;
    $scope.avatarpicture = null;
    $scope.response = null;
    $scope.query = "";
    $scope.webview = "";

    
    $scope.doRefresh = function() {
        //console.log("NoteWallCtrl doRefresh");
        getUser();
        $scope.lastnoteid = 0;
        $scope.getNotes();
    }
    

    $scope.makeNoteFavorite = function(note){
        if (note.favorite == 1) {
            note.favorite = 0;
            note.favorites = +note.favorites - 1;
            noteFactory.deleteNoteFavorite(note.id,$scope.user.id).then(function(response) {
                $rootScope.$broadcast('refreshFav');
            });
        } else {
            note.favorite = 1;
            note.favorites = +note.favorites + 1;
            noteFactory.insertNoteFavorite(note.id,$scope.user.id,note.fid,$scope.user.name,
                  $rootScope.escapeHTML(note.descr).substring(0,30)).then(function(response) {
                $rootScope.$broadcast('refreshFav');
            });
        }
    }

    $scope.makeNoteAmen = function(note){
        if (note.amen == 1) {
            note.amen = 0;
            note.amens = +note.amens - 1;
            noteFactory.deleteNoteAmen(note.id,$scope.user.id).then(function(response) {
            });
        } else {
            note.amen = 1;
            note.amens = +note.amens + 1;
            noteFactory.insertNoteAmen(note.id,$scope.user.id,note.fid,$scope.user.name,
                                           note.descr).then(function(response) {
            });
        }
    }

    function getUser() {
        userFactory.hgetUser($scope.user.fid, $scope.user.fid).then(function(response) {
            $scope.userview = response.data[0];
        });
    };
    
    $scope.getNotes = function() {
        noteFactory.getWallNotes($scope.user.fid, $scope.lastnoteid)
            .then(function(response) {
                $scope.notes = noteFactory.getWallNotesCache();
                (response.data.length < 10) ?  $scope.endofdata = true : $scope.endofdata = false;                  
                if (response.data.length > 0) $scope.lastnoteid = response.data[response.data.length-1].id;
                $scope.$broadcast('scroll.refreshComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
    }

    $rootScope.$on('refreshWall', function (event, args) {
        $scope.doRefresh();
        console.log("got refreshWall. calling doRefresh");
    });

    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("NoteWallCtrl beforeEnter callback fired");
        $scope.user = $rootScope.user;
        $rootScope.tab = "wall";
        $scope.tab = $rootScope.tab;
        getUser();
        $scope.notes = noteFactory.getWallNotesCache();
    });
})

.controller('EventCtrl', function($scope, $stateParams, $http, $ionicHistory, $state, $rootScope, $ionicLoading) {
    //console.log("EventCtrl");
    $scope.query = "";
    $scope.user = null;
    $scope.events = null;

    //getLocalStore();
    function getLocalStore() {
        $scope.user = $rootScope.user;
        getEvents();
    }


    $scope.doRefresh = function() {
        //console.log("EventCtrl doRefresh");
        //location.reload();
        getLocalStore();
    }
    
    function getEvents(){
        //console.log("EventCtrl get events for fid=" + $scope.user.id);            
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/getEvents.php?fid=" + $scope.user.id)
            .success(function(data){
                //console.log("EventCtrl got events for fid="+$scope.user.id);
                $scope.events = data;
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            })
        ;
    }

    $scope.viewEventNote = function(event) {
        //console.log("EventCtrl update event=" + event.id);
        $state.go('tab.eventnoteview', { 'noteid': event.noteid });
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/updateEvent.php?id=" + event.id)
            .success(function(data){
                //console.log("EventCtrl updated event");
            })
            .error(function (e) {
                console.log("EventCtrl Something went wrong with viewEventNote. Error message: " + e.message)
            })
        ;
    }

    $scope.viewFollowRequest = function(event) {
        //console.log("EventCtrl update event=" + event.id);
        $state.go('tab.eventuserview', { 'notefid': event.efid });
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/updateEvent.php?id=" + event.id)
            .success(function(data){
                //console.log("EventCtrl updated event");
            })
            .error(function (e) {
                console.log("EventCtrl Something went wrong with viewFollowRequest. Error message: " + e.message)
            })
        ;
    }

    $scope.approveFollower = function(event) {
        //console.log("EventCtrl approveFollower event=" + event.followerid);
        //console.log("EventCtrl approveFollower fid=" + event.efid);
        //console.log("EventCtrl approveFollower ffid=" + event.fid );
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/approveFollower.php?fid=" + event.efid + "&ffid=" + event.fid)
            .success(function(data){
                //console.log("EventCtrl updated event");
                getLocalStore();
            })
            .error(function (e) {
                console.log("EventCtrl Something went wrong with approveFollower. Error message: " + e.message)
            })
        ;
    }

    $scope.rejectFollower = function(event){
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/deleteFollower.php?fid=" + event.efid + "&ffid=" + event.fid)
            .success(function(data){
                getLocalStore();
            })
            .error(function (e) {
                console.log("EventCtrl Something went wrong with rejectFollower. Error message: " + e.message)
            })
        ;
    };
    
    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("EventCtrl beforeEnter callback fired");
        $rootScope.tab = "event";
        $scope.tab = $rootScope.tab;
        getLocalStore();
    });
})

.controller('SearchCtrl', function($scope, $stateParams, $http, $ionicHistory, $rootScope,
                  $ionicModal, $ionicLoading, $ionicScrollDelegate, userFactory, noteFactory) {
    //console.log("SearchCtrl");
    $scope.endofdata = false;
    $scope.notes = [];
    $scope.lastnoteid = 0;
    $scope.endofuserdata = false;
    $scope.users = [];
    $scope.lastuserid = 0;
    $scope.user = null;
    $scope.notes = null;
    $scope.data = {reason: 'xx'};
    $scope.userquery = "";
    $scope.notequery = "";
    $scope.searchstr = "";
    $scope.webview = "";
    $scope.category = "users";
    $scope.user = $rootScope.user;
    userFactory.hgetUsers($scope.user.fid).then(function(response) {
        $scope.users = response.data;
    });

    $scope.doRefresh = function() {
        //console.log("SearchCtrl doRefresh");
        $scope.lastnoteid = 0;
        $ionicScrollDelegate.scrollTop();
        $scope.searchstr = "";
        $scope.category = "users";
        userFactory.hgetUsers($scope.user.fid).then(function(response) {
            $scope.users = response.data;
            $scope.$broadcast('scroll.refreshComplete');
            //console.log("just reinitialized users");
        });
     };

    $scope.setNoteCategory = function(){
        $scope.category = 'notes';
        $scope.searchstr = "";
        $scope.notes = [];
    }

    $scope.setUserCategory = function(){
        $scope.category = 'users';
        $scope.searchstr = "";
        $scope.users = [];
        userFactory.hgetUsers($scope.user.fid).then(function(response) {
            $scope.users = response.data;
            //console.log("just reinitialized users");
        });
    }
     
    $scope.makeNoteFavorite = function(note){
        if (note.favorite == 1) {
            note.favorite = 0;
            note.favorites = +note.favorites - 1;
            noteFactory.deleteNoteFavorite(note.id,$scope.user.id).then(function(response) {
                $rootScope.$broadcast('refreshFav');
            });
        } else {
            note.favorite = 1;
            note.favorites = +note.favorites + 1;
            noteFactory.insertNoteFavorite(note.id,$scope.user.id,note.fid,$scope.user.name,
                  $rootScope.escapeHTML(note.descr).substring(0,30)).then(function(response) {
                $rootScope.$broadcast('refreshFav');
            });
        }
    }

    $scope.makeNoteAmen = function(note){
        if (note.amen == 1) {
            note.amen = 0;
            note.amens = +note.amens - 1;
            noteFactory.deleteNoteAmen(note.id,$scope.user.id).then(function(response) {
            });
        } else {
            note.amen = 1;
            note.amens = +note.amens + 1;
            noteFactory.insertNoteAmen(note.id,$scope.user.id,note.fid,$scope.user.name,
                                           note.descr).then(function(response) {
            });
        }
    }
    
    $scope.insertFollower = function(follower) {
        if (follower.approved == null) {
            // if approved is null we want to add a new follower record (may or may not be approved depending on privacy setting of the one being followed)
            (follower.privacy == 0) ? follower.approved = 1 : follower.approved = 0;
            userFactory.insertFollower($scope.user.id, $scope.user.name, follower.fid,
                                       follower.name, follower.privacy).then(function(response) {
                noteFactory.getFeedNotes($scope.user.fid, 0);
            });
            
        } else {
            // we are either pending or following. we want to delete the follower either way
            follower.approved = null;
            userFactory.deleteFollower($scope.user.id, follower.fid).then(function(response) {
                noteFactory.getFeedNotes($scope.user.fid, 0);
            });
        }
        //$rootScope.$broadcast('refreshFeed');
        //$rootScope.$broadcast('refreshSearch');
        //$rootScope.$broadcast('refreshFav');

    }


    $scope.searchNotes = function(type) {
        $rootScope.showSpinner();
        if (type == "load") $scope.lastnoteid = 0;
        noteFactory.searchSearchNotes($scope.user.fid, $scope.lastnoteid, $scope.searchstr)
            .then(function(response) {
                $ionicLoading.hide();
                $scope.notes = noteFactory.getSearchNotesCache();
                (response.data.length < 10) ?  $scope.endofdata = true : $scope.endofdata = false;                  
                if (response.data.length > 0) $scope.lastnoteid = response.data[response.data.length-1].id;
                $scope.$broadcast('scroll.refreshComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
    }

    $scope.searchUsers = function() {
        //console.log("SearchCtrl searchUsers fid=" + $scope.user.fid + " searchstr=" + $scope.searchstr);            
        $rootScope.showSpinner();
        $scope.userquery = "";
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/searchUsers.php?fid=" + $scope.user.id + "&searchstr=" + $scope.searchstr)
            .success(function(data){
                $ionicLoading.hide();
                //console.log("SearchCtrl got Users");
                $scope.users = data;
            })
          .finally(function() {
                $scope.$broadcast('scroll.refreshComplete');
          })
        ;
    }

    $scope.openReport = function (note) {
         $ionicModal.fromTemplateUrl('templates/report.html', {
           scope: $scope
         })
         .then(function(modal) {
            $scope.noteid = note.id;
            $scope.notefid = note.fid;
            $scope.notename = note.name;
            $scope.modal = modal;
            $scope.modal.show();
         });
    }

    $scope.closeModal = function() {
        $scope.modal.hide();
        resetModal();
    };

    $scope.reportObjectionable = function(){
        noteFactory.reportObjectionable($scope.noteid,$scope.user.fid, $scope.data.reason).then(function(response) {
            $rootScope.$broadcast("refreshFeed");
            $rootScope.$broadcast("refreshFav");
            $rootScope.$broadcast("refreshSearch");
            $scope.modal.hide();
            resetModal();
        });
    }

    $scope.unFollow = function(){
        userFactory.unFollow($scope.user.id,$scope.notefid).then(function(response) {
            $rootScope.$broadcast("refreshFeed");
            $rootScope.$broadcast("refreshFav");
            $rootScope.$broadcast("refreshSearch");
            $rootScope.$broadcast("refreshUser");
            $scope.modal.hide();
            resetModal();
        });
    }

    function resetModal() {
        $scope.noteid = 0;
        $scope.notefid = 0;
        $scope.notename = '';
        $scope.modal.remove();
        $scope.data.reason = "xx";          
    }

    $rootScope.$on('refreshSearch', function (event, args) {
        $scope.doRefresh();
        console.log("got refreshSearch. calling doRefresh");
    });
            
            
    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("SearchCtrl beforeEnter callback fired");
        $scope.user = $rootScope.user;
        $rootScope.tab = "search";
        $scope.tab = $rootScope.tab;
    });

})


.controller('UserViewCtrl', function($scope, $stateParams, $http, $ionicHistory, $rootScope, $ionicLoading,
                  $ionicModal, $ionicScrollDelegate, userFactory, noteFactory) {
    //console.log("UserViewCtrl");
    $scope.endofdata = false;
    $scope.notes = [];
    $scope.lastnoteid = 0;
    $scope.data = {reason: 'xx'};

    $scope.user = null;
    $scope.follower = null;
    $scope.query = "";

    $scope.doRefresh = function() {
        //console.log("UserViewCtrl doRefresh");
        $rootScope.feedRefresh = false;
        $scope.lastnoteid = 0;
        $ionicScrollDelegate.scrollTop();
        getUser();
        $scope.getNotes();
    }

    $scope.makeNoteFavorite = function(note){
        if (note.favorite == 1) {
            note.favorite = 0;
            note.favorites = +note.favorites - 1;
            noteFactory.deleteNoteFavorite(note.id,$scope.user.id).then(function(response) {
                $rootScope.$broadcast('refreshFav');
            });
        } else {
            note.favorite = 1;
            note.favorites = +note.favorites + 1;
            noteFactory.insertNoteFavorite(note.id,$scope.user.id,note.fid,$scope.user.name,
                  $rootScope.escapeHTML(note.descr).substring(0,30)).then(function(response) {
                $rootScope.$broadcast('refreshFav');
            });
        }
    }

    $scope.makeNoteAmen = function(note){
        if (note.amen == 1) {
            note.amen = 0;
            note.amens = +note.amens - 1;
            noteFactory.deleteNoteAmen(note.id,$scope.user.id).then(function(response) {
            });
        } else {
            note.amen = 1;
            note.amens = +note.amens + 1;
            noteFactory.insertNoteAmen(note.id,$scope.user.id,note.fid,$scope.user.name,
                                           note.descr).then(function(response) {
            });
        }
    }

    $scope.getNotes = function() {
        noteFactory.getUserNotes($stateParams.notefid, $scope.lastnoteid, $scope.user.fid)
            .then(function(response) {
                $scope.notes = noteFactory.getUserNotesCache();
                (response.data.length < 10) ?  $scope.endofdata = true : $scope.endofdata = false;                  
                if (response.data.length > 0) $scope.lastnoteid = response.data[response.data.length-1].id;
                $scope.$broadcast('scroll.refreshComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
    }

    function getUser() {
        userFactory.hgetUser($scope.user.fid,$stateParams.notefid).then(function(response) {
            $scope.userview = response.data[0];
        });
    };

    $scope.insertFollower = function(follower) {
        if (follower.approved == null) {
            // if approved is null we want to add a new follower record (may or may not be approved depending on privacy setting of the one being followed)
            (follower.privacy == 0) ? follower.approved = 1 : follower.approved = 0;
            userFactory.insertFollower($scope.user.id, $scope.user.name, follower.fid,
                                       follower.name, follower.privacy).then(function(response) {
                
            });
        } else {
            // we are either pending or following. we want to delete the follower either way
            follower.approved = null;
            userFactory.deleteFollower($scope.user.id, follower.fid).then(function(response) {
                
            });
        }
        //$rootScope.$broadcast('refreshFeed');
        //$rootScope.$broadcast('refreshSearch');
        //$rootScope.$broadcast('refreshFav');
    }

    $scope.openReport = function (note) {
         $ionicModal.fromTemplateUrl('templates/report.html', {
           scope: $scope
         })
         .then(function(modal) {
            $scope.noteid = note.id;
            $scope.notefid = note.fid;
            $scope.notename = note.name;
            $scope.modal = modal;
            $scope.modal.show();
         });
    }

    $scope.closeModal = function() {
        $scope.modal.hide();
        resetModal();
    };

    $scope.reportObjectionable = function(){
        noteFactory.reportObjectionable($scope.noteid,$scope.user.fid, $scope.data.reason).then(function(response) {
            $rootScope.$broadcast("refreshFeed");
            $rootScope.$broadcast("refreshFav");
            $rootScope.$broadcast("refreshSearch");
            $scope.modal.hide();
            resetModal();
            $ionicHistory.goBack();                
        });
    }

    $scope.unFollow = function(){
        userFactory.unFollow($scope.user.id,$scope.notefid).then(function(response) {
            $rootScope.$broadcast("refreshFeed");
            $rootScope.$broadcast("refreshFav");
            $rootScope.$broadcast("refreshSearch");
            $rootScope.$broadcast("refreshUser");
            $scope.modal.hide();
            resetModal();
            $ionicHistory.goBack();                

        });
    }

    function resetModal() {
        $scope.noteid = 0;
        $scope.notefid = 0;
        $scope.notename = '';
        $scope.modal.remove();
        $scope.data.reason = "xx";          
    }

    $rootScope.$on('refreshUser', function (event, args) {
        $scope.doRefresh();
        console.log("got refreshUser. calling doRefresh");
    });
    
    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("UserViewCtrl beforeEnter callback fired");
        $scope.user = $rootScope.user;
        $scope.tab = $rootScope.tab;
        getUser();
    });
})

.controller('AddCommentCtrl', function($scope, $stateParams, $http, $ionicHistory,
                $rootScope, $ionicScrollDelegate, $ionicLoading, noteFactory) {
    $scope.insertComment = function(note) {
        //console.log("NoteCommentCtrl comment.descr="+$scope.comment.descr);
        // cleanup bad characters
        var newcommentdescr = $rootScope.escapeHTML($scope.comment.descr);
        var title = $rootScope.escapeHTML(note.title);
        var notedescr = $rootScope.escapeHTML(note.descr);

        // create a description for the event description
        var eventdescr = "a picture.";
        if (title != "") {
            eventdescr = title;
        }
        if (title == "" && notedescr != "") {
            eventdescr = notedescr.substr(0,20);
        }
        
        //console.log("NoteCommentCtrl final eventdescr="+eventdescr);
        //console.log("NoteCommentCtrl final newcommentdescr="+newcommentdescr);

        var FormData = {
          'NoteID' : note.id,
          'fid' : $scope.user.id,
          'name' : $scope.user.name,
          'descr' : newcommentdescr,
          'efid' : note.fid,
          'notedescr' : eventdescr
        };

        noteFactory.insertComment(FormData).then(function(response) {
            note.comments = note.comments + 1;
            $ionicHistory.goBack();                
        });
    }
    
    $scope.makeNoteFavorite = function(note){
        if (note.favorite == 1) {
            note.favorite = 0;
            note.favorites = +note.favorites - 1;
            noteFactory.deleteNoteFavorite(note.id,$scope.user.id).then(function(response) {
                $rootScope.$broadcast('refreshFav');
            });
        } else {
            note.favorite = 1;
            note.favorites = +note.favorites + 1;
            noteFactory.insertNoteFavorite(note.id,$scope.user.id,note.fid,$scope.user.name,
                  $rootScope.escapeHTML(note.descr).substring(0,30)).then(function(response) {
                $rootScope.$broadcast('refreshFav');
            });
        }
    }

    $scope.makeNoteAmen = function(note){
        if (note.amen == 1) {
            note.amen = 0;
            note.amens = +note.amens - 1;
            noteFactory.deleteNoteAmen(note.id,$scope.user.id).then(function(response) {
            });
        } else {
            note.amen = 1;
            note.amens = +note.amens + 1;
            noteFactory.insertNoteAmen(note.id,$scope.user.id,note.fid,$scope.user.name,
                                           note.descr).then(function(response) {
            });
        }
    }

    function getNote() {
        if ($scope.tab == 'feed') {
            $scope.note = noteFactory.getFeedNote($stateParams.noteid);
            if ($scope.note != null) {
                noteFactory.getFeedComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;    
                });
            } else {
                noteFactory.getNote($stateParams.noteid, $scope.user.fid).then(function(response) {
                    $scope.note = response.data[0];
                });
                noteFactory.getComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;
                    
                });
            }
        } else
        if ($scope.tab == 'search') {
            $scope.note = noteFactory.getSearchNote($stateParams.noteid);
            if ($scope.note != null) {
                noteFactory.getSearchComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;    
                });
            } else {
                noteFactory.getNote($stateParams.noteid, $scope.user.fid).then(function(response) {
                    $scope.note = response.data[0];
                });
                noteFactory.getComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;
                });
            }
        } else
        if ($scope.tab == 'fav') {
            $scope.note = noteFactory.getFavoriteNote($stateParams.noteid);
            if ($scope.note != null) {
                noteFactory.getFavoriteComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;    
                });
            } else {
                noteFactory.getNote($stateParams.noteid, $scope.user.fid).then(function(response) {
                    $scope.note = response.data[0];
                });
                noteFactory.getComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;
                });
            }
        } else
        if ($scope.tab == 'event') {
              noteFactory.getNote($stateParams.noteid, $scope.user.fid).then(function(response) {
                  $scope.note = response.data[0];
              });
              noteFactory.getComments($stateParams.noteid).then(function(response) {
                  $scope.comments = response.data;
              });
        } else
        if ($scope.tab == 'wall') {
            $scope.note = noteFactory.getWallNote($stateParams.noteid);
            if ($scope.note != null) {
                noteFactory.getWallComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;    
                });
            } else {
                noteFactory.getNote($stateParams.noteid, $scope.user.fid).then(function(response) {
                    $scope.note = response.data[0];
                });
                noteFactory.getComments($stateParams.noteid).then(function(response) {
                    $scope.comments = response.data;
                });
            }
        }
    }

    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("NoteCommentCtrl beforeEnter callback fired");
        $scope.user = $rootScope.user;
        $scope.tab = $rootScope.tab;
        getNote();
    })
})

.controller('FollowingCtrl', function($scope, $http, $ionicHistory, $rootScope, $ionicLoading, userFactory) {
    //console.log("FollowingCtrl");
    $scope.user = $rootScope.user;
    $scope.query = "";
    $scope.users = [];
    userFactory.getFollowing($scope.user.fid).then(function(response) {
            $scope.users = response.data;
            $scope.$broadcast('scroll.refreshComplete');
    });

    $scope.doRefresh = function() {
        //console.log("FollowingCtrl doRefresh");
        userFactory.getFollowing($scope.user.fid).then(function(response) {
                $scope.users = response.data;
                $scope.$broadcast('scroll.refreshComplete');
        });
    }
    
     $scope.insertFollower = function(follower) {
        if (follower.approved == null) {
            // if approved is null we want to add a new follower record (may or may not be approved depending on privacy setting of the one being followed)
            (follower.privacy == 0) ? follower.approved = 1 : follower.approved = 0;
            userFactory.insertFollower($scope.user.id, $scope.user.name, follower.fid,
                                       follower.name, follower.privacy).then(function(response) {
                
            });
        } else {
            // we are either pending or following. we want to delete the follower either way
            follower.approved = null;
            userFactory.deleteFollower($scope.user.id, follower.fid).then(function(response) {
                
            });
        }
        //$rootScope.$broadcast('refreshFeed');
        //$rootScope.$broadcast('refreshSearch');
        //$rootScope.$broadcast('refreshFav');

    }

    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("FollowingCtrl beforeEnter callback fired");
        $scope.user = $rootScope.user;
        $scope.tab = $rootScope.tab;
    });
})

.controller('FollowerCtrl', function($scope, $stateParams, $http, $ionicHistory, $rootScope, $ionicLoading, userFactory) {
    //console.log("FollowerCtrl");
    $scope.query = "";
    $scope.users = [];
    
    userFactory.getFollower($scope.user.fid).then(function(response) {
            $scope.users = response.data;
            $scope.$broadcast('scroll.refreshComplete');
    });

    $scope.doRefresh = function() {
        //console.log("FollowerCtrl doRefresh");
        userFactory.getFollower($scope.user.fid).then(function(response) {
                $scope.users = response.data;
                $scope.$broadcast('scroll.refreshComplete');
        });
    }
    
    $scope.insertFollower = function(follower) {
        if (follower.approved == null) {
            // if approved is null we want to add a new follower record (may or may not be approved depending on privacy setting of the one being followed)
            (follower.privacy == 0) ? follower.approved = 1 : follower.approved = 0;
            userFactory.insertFollower($scope.user.id, $scope.user.name, follower.fid,
                                       follower.name, follower.privacy).then(function(response) {
                
            });
        } else {
            // we are either pending or following. we want to delete the follower either way
            follower.approved = null;
            userFactory.deleteFollower($scope.user.id, follower.fid).then(function(response) {
                
            });
        }
        //$rootScope.$broadcast('refreshFeed');
        //$rootScope.$broadcast('refreshSearch');
        //$rootScope.$broadcast('refreshFav');
    }

    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("NoteFavoriteCtrl beforeEnter callback fired");
        $scope.user = $rootScope.user;
        $scope.tab = $rootScope.tab;
    });
})

.controller('ProfileCtrl', function($scope, $stateParams, $http, $ionicHistory, $state, $rootScope,
                          $ionicLoading, $cordovaCamera) {
    //console.log("ProfileCtrl");
    $scope.user = null;
    $scope.userview = null;
    $scope.bannerpicCamera = 0;
    $scope.bannerpicLibrary = 0;
    $scope.bannerpicture = "";
    $scope.bannerpicnum = 1;
    $scope.avatarpicnum = 1;
    $scope.avatarpicCamera = 0;
    $scope.avatarpicLibrary = 0;
    $scope.avatarpicture = "";
    $scope.response = null;
    $scope.name = "";
    $scope.username = null;
    $scope.password = null;
    $scope.confirmpassword = null;
    $scope.validlogin = 1;
    $scope.gnuser = null;
    $scope.native = $rootScope.native;
    $scope.bannerimgURI = null;
    $scope.avatarimgURI = null;
    $scope.privacy = false;
    $scope.cloaking = false;
    
    //getLocalStore();
    function getLocalStore() {
        $scope.user = $rootScope.user;
        $scope.username = $scope.user.username;
        $scope.name = $scope.user.name;
        getUser();
    }

    $scope.doRefresh = function() {
        //console.log("ProfileCtrl doRefresh");
        //getLocalStore();
        //location.reload();
    }

    function createLocalStore() {
        if ($scope.user != null) {
            //console.log("ProfileCtrl setting local storage"+$scope.user.name);
            localStorage.setItem('gnuser', JSON.stringify({
                id: $scope.user.fid,
                name: $scope.name,
                username: $scope.username,
                fid: $scope.user.fid
            }));
        } else {
            //console.log("ProfileCtrl nulling local storage");
            localStorage.setItem('gnuser', JSON.stringify({
                id: '',
                name: '',
                username: '',
                fid: ''
            }));
        }
    }

    var fileBanner = document.getElementById('banner');
    fileBanner.addEventListener('change', function(e) {
        $scope.updateBanner();
    });  
      
    $scope.updateBanner = function() {
        //console.log("updateBanner");
        var file = document.getElementById('banner').files[0];
        //console.log("Name: " + file.name + "\n" + "Last Modified Date :" + file.lastModifiedDate);
        var reader = new FileReader();
        reader.onloadend = function()
        {
            var data = reader.result;
            //console.log("reader.result="+reader.result);
            $scope.bannerimgURI = data;
            var data_index = data.indexOf('base64') + 7;
            //console.log("data_index="+data_index);
            $scope.bannerpicture = data.slice(data_index, data.length);
            //console.log("bannerpicture="+$scope.bannerpicture);
            //$scope.bannerpicnum = +$scope.userview.bannerpicnum + 1;
            $scope.$apply();
            var picnum = (+$scope.userview.bannerpicnum) + 1;
            $scope.bannerpicnum = picnum.toString();

            $scope.bannerpicCamera = 0;
            $scope.bannerpicLibrary = 0;

            var FormData = {
              'name' : $scope.user.name,
              'fid' : $scope.user.id,
              'bannerpicnum' : $scope.bannerpicnum,
              'bannerpicture' : $scope.bannerpicture
            };

            //console.log("name="+$scope.user.name);
            //console.log("fid="+$scope.user.id);
            //console.log("bannerpicnum="+$scope.bannerpicnum);
            //console.log("bannerpicture="+$scope.bannerpicture);

            $http({
              method: 'POST',
              url: 'https://www.gracenoteapp.com/gracenote/ajax/updateProfileBanner.php',
              data: FormData,
              headers: {'Content-Type': 'application/x-www-form-urlencoded'},
            })
            .success(function(response) {
                //console.log("returned from post!");
                $scope.response = response;
                getUser();
                //location.reload();
                //$state.go('tab.notewall', {}, {location: "replace", reload: true});                                    

            });
        }
        reader.readAsDataURL(file);
    }        


    var fileAvatar = document.getElementById('avatar');
    fileAvatar.addEventListener('change', function(e) {
        $scope.updateAvatar();
    });  
      
    $scope.updateAvatar = function() {
        //console.log("updateAvatar");
        var file = document.getElementById('avatar').files[0];
        //console.log("Name: " + file.name + "\n" + "Last Modified Date :" + file.lastModifiedDate);
        var reader = new FileReader();
        reader.onloadend = function()
        {
            var data = reader.result;
            //console.log("reader.result="+reader.result);
            $scope.avatarimgURI = data;
            var data_index = data.indexOf('base64') + 7;
            //console.log("data_index="+data_index);
            $scope.avatarpicture = data.slice(data_index, data.length);
            //console.log("avatarpicture="+$scope.avatarpicture);
            //$scope.avatarpicnum = +$scope.userview.avatarpicnum + 1;
            $scope.$apply();
            var picnum = (+$scope.userview.avatarpicnum) + 1;
            $scope.avatarpicnum = picnum.toString();

            $scope.avatarpicCamera = 0;
            $scope.avatarpicLibrary = 0;

            var FormData = {
              'name' : $scope.user.name,
              'fid' : $scope.user.id,
              'avatarpicnum' : $scope.avatarpicnum,
              'avatarpicture' : $scope.avatarpicture
            };

            //console.log("name="+$scope.user.name);
            //console.log("fid="+$scope.user.id);
            //console.log("avatarpicnum="+$scope.avatarpicnum);
            //console.log("avatarpicture="+$scope.avatarpicture);

            $http({
              method: 'POST',
              url: 'https://www.gracenoteapp.com/gracenote/ajax/updateProfileAvatar.php',
              data: FormData,
              headers: {'Content-Type': 'application/x-www-form-urlencoded'},
            })
            .success(function(response) {
                //console.log("returned from post!");
                $scope.response = response;
                getUser();
                //location.reload();
                //$state.go('tab.notewall', {}, {location: "replace", reload: true});                                    

            });
        }
        reader.readAsDataURL(file);
    }        

    $scope.getBannerPicture = function() {
        //console.log("ProfileCtrl In getBannerPicture");
        //$scope.bannerpicture = "Hello World";
        var options = {
                quality : 75, 
                destinationType : Camera.DestinationType.DATA_URL, 
                sourceType : Camera.PictureSourceType.PHOTOLIBRARY, 
                allowEdit : true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 300,
                targetHeight: 300,
                popoverOptions: CameraPopoverOptions,
                saveToPhotoAlbum: true
        };

            $cordovaCamera.getPicture(options)
            .then( function(result){
                console.log("ProfileCtrl Got BannerPicture");
                //console.log("ProfileCtrl Got BannerPicture=" + result);
                $scope.bannerpicture = result;
                $scope.bannerimgURI = "data:image/jpeg;base64," + result;
                $scope.$apply();
                var picnum = (+$scope.userview.bannerpicnum) + 1;
                $scope.bannerpicnum = picnum.toString();
                $scope.bannerpicLibrary = 1;
                $scope.bannerpicCamera = 0;

                var FormData = {
                  'name' : $scope.user.name,
                  'fid' : $scope.user.id,
                  'bannerpicnum' : $scope.bannerpicnum,
                  'bannerpicture' : $scope.bannerpicture,
                };
                
                $http({
                  method: 'POST',
                  url: 'https://www.gracenoteapp.com/gracenote/ajax/updateProfileBanner.php',
                  data: FormData,
                  headers: {'Content-Type': 'application/x-www-form-urlencoded'},
                })
                .success(function(response) {
                    $scope.response = response;
                    //location.reload();
                    getUser();
                })
                .error(function(response) {
                    $scope.response = response || "Request failed";
                });
            })
            .error(function (e) {
                console.log("ProfileCtrl Something went wrong with getBannerPicture. Error message: " + e.message)
            })
        ;
    }
    
    $scope.takeBannerPicture = function() {
        //console.log("ProfileCtrl In takeBannerPicture");
        var options = {
          quality: 75,
          destinationType: Camera.DestinationType.DATA_URL,
          sourceType: Camera.PictureSourceType.CAMERA,
          encodingType: Camera.EncodingType.JPEG,
          allowEdit: true,
          targetWidth: 300,
          targetHeight: 300,
          popoverOptions: CameraPopoverOptions,
          saveToPhotoAlbum: true
        };

        $cordovaCamera.getPicture(options)
            .then( function(result){
                //console.log("ProfileCtrl Took BannerPicture");
                //console.log("ProfileCtrl Took BannerPicture=" + result);
                $scope.bannerpicture = result;
                $scope.bannerimgURI = "data:image/jpeg;base64," + result;
                $scope.$apply();
                var picnum = (+$scope.userview.bannerpicnum) + 1;
                $scope.bannerpicnum = picnum.toString();
                $scope.bannerpicCamera = 1;
                $scope.bannerpicLibrary = 0;

                var FormData = {
                  'name' : $scope.user.name,
                  'fid' : $scope.user.id,
                  'bannerpicnum' : $scope.bannerpicnum,
                  'bannerpicture' : $scope.bannerpicture,
                };
                
                $http({
                  method: 'POST',
                  url: 'https://www.gracenoteapp.com/gracenote/ajax/updateProfileBanner.php',
                  data: FormData,
                  headers: {'Content-Type': 'application/x-www-form-urlencoded'},
                })
                .success(function(response) {
                    $scope.response = response;
                    //$ionicHistory.goBack();
                    //supersonic.ui.layers.pop();
                    getUser();
                })
                .error(function(response) {
                    $scope.response = response || "Request failed";
                });
            })
            .error(function (e) {
                console.log("ProfileCtrl Something went wrong with takeBannerPicture. Error message: " + e.message)
            })
        ;
    }

    $scope.getAvatarPicture = function() {
        //console.log("ProfileCtrl In getAvatarPicture");
        var options = {
                quality : 50, 
                destinationType : Camera.DestinationType.DATA_URL, 
                sourceType : Camera.PictureSourceType.PHOTOLIBRARY, 
                allowEdit : true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 50,
                targetHeight: 50,
                popoverOptions: CameraPopoverOptions,
                saveToPhotoAlbum: true
        };

            $cordovaCamera.getPicture(options)
            .then( function(result){
                //console.log("ProfileCtrl Got AvatarPicture");
                //console.log("ProfileCtrl Got AvatarPicture=" + result);
                $scope.avatarpicture = result;
                $scope.avatarimgURI = "data:image/jpeg;base64," + result;
                $scope.$apply();
                var picnum = (+$scope.userview.avatarpicnum) + 1;
                $scope.avatarpicnum = picnum.toString();
                $scope.avatarpicLibrary = 1;
                $scope.avatarpicCamera = 0;

                var FormData = {
                  'name' : $scope.user.name,
                  'fid' : $scope.user.id,
                  'avatarpicnum' : $scope.avatarpicnum,
                  'avatarpicture' : $scope.avatarpicture
                };
                
                $http({
                  method: 'POST',
                  url: 'https://www.gracenoteapp.com/gracenote/ajax/updateProfileAvatar.php',
                  data: FormData,
                  headers: {'Content-Type': 'application/x-www-form-urlencoded'},
                })
                .success(function(response) {
                    $scope.response = response;
                    //location.reload();
                    getUser();
                })
                .error(function(response) {
                    $scope.response = response || "Request failed";
                });


            })
            .error(function (e) {
                console.log("ProfileCtrl Something went wrong with getAvatarPicture. Error message: " + e.message)
            })
        ;
    }
    
    $scope.takeAvatarPicture = function() {
        //console.log("ProfileCtrl In takeBannerPicture");
        var options = {
          quality: 50,
          destinationType: Camera.DestinationType.DATA_URL,
          sourceType: Camera.PictureSourceType.CAMERA,
          encodingType: Camera.EncodingType.JPEG,
          allowEdit: true,
          targetWidth: 50,
          targetHeight: 50,
          popoverOptions: CameraPopoverOptions,
          saveToPhotoAlbum: true
        };

        $cordovaCamera.getPicture(options)
            .then( function(result){
                //console.log("ProfileCtrl Took AvatarPicture");
                //console.log("ProfileCtrl Took AvatarPicture=" + result);
                $scope.avatarpicture = result;
                $scope.avatarimgURI = "data:image/jpeg;base64," + result;
                $scope.$apply();
                var picnum = (+$scope.userview.avatarpicnum) + 1;
                $scope.avatarpicnum = picnum.toString();
                $scope.avatarpicCamera = 1;
                $scope.avatarpicLibrary = 0;

                var FormData = {
                  'name' : $scope.user.name,
                  'fid' : $scope.user.id,
                  'avatarpicnum' : $scope.avatarpicnum,
                  'avatarpicture' : $scope.avatarpicture
                };
                
                $http({
                  method: 'POST',
                  url: 'https://www.gracenoteapp.com/gracenote/ajax/updateProfileAvatar.php',
                  data: FormData,
                  headers: {'Content-Type': 'application/x-www-form-urlencoded'},
                })
                .success(function(response) {
                    $scope.response = response;
                    //location.reload();
                    getUser();
                })
                .error(function(response) {
                    $scope.response = response || "Request failed";
                });
            })
            .error(function (e) {
                console.log("ProfileCtrl Something went wrong with getAvatarPicture. Error message: " + e.message)
            })
        ;
    }
    getUser();
    function getUser() {
      // make both the login user
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/getUser.php?fid=" + $stateParams.fid + "&ffid=" + $stateParams.fid)
          .success(function (data) {
              $scope.userview = data[0];
              $scope.privacy = ($scope.userview.privacy == '1');
              $scope.cloaking = ($scope.userview.cloaking == '1');
              //$scope.$apply();
          })
          .finally(function() {
                $scope.$broadcast('scroll.refreshComplete');
          })
        ;
    };

    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("ProfileCtrl beforeEnter callback fired");
        $scope.tab = $rootScope.tab;
        getLocalStore();
    });

    $scope.updateOptions = function() {
        //console.log("ProfileCtrl updateOptions fid=" + $stateParams.fid + "&privacy=" + $scope.privacy + "&cloaking=" + $scope.cloaking);
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/updateOptions.php?fid=" + $stateParams.fid + "&privacy=" + $scope.privacy + "&cloaking=" + $scope.cloaking)
          .success(function (data) {
              $scope.userview = data[0];
              $scope.privacy = ($scope.userview.privacy == '1');
              $scope.cloaking = ($scope.userview.cloaking == '1');
              //$scope.$apply();
          })
          .finally(function() {
                $scope.$broadcast('scroll.refreshComplete');
                $ionicHistory.goBack();

          })
        ;
    };

    $scope.updateProfile = function(){
        //console.log("ProfileCtrl in updateProfile");
        //console.log("ProfileCtrl in updateProfile username="+$scope.user.username);
        //console.log("ProfileCtrl in updateProfile newusername="+$scope.username);
        //console.log("ProfileCtrl in updateProfile password="+$scope.password);
        //console.log("ProfileCtrl in updateProfile name="+$scope.name);
        //console.log("ProfileCtrl login username=" + $scope.user.username + " newusername=" + $scope.username + " password=" + $rootScope.MD5($scope.password) + "&name=" + $scope.name);
        
        $scope.response = "";
        if ($scope.name == "") {
            $scope.response = $scope.response + "You must enter your name. "
            $scope.password = "";
            $scope.validlogin = 5;
        }
        if ($scope.username == "") {
            $scope.response = $scope.response + "You must enter your email. "
            $scope.password = "";
            $scope.validlogin = 5;
        }
        if ($scope.password == null || $scope.password == "") {
            $scope.response = $scope.response + "You must enter a password. "
            $scope.password = "";
            $scope.validlogin = 6;
        }
        if ($scope.confirmpassword != null) {
            if ($rootScope.MD5($scope.password) != $rootScope.MD5($scope.confirmpassword)) {
                $scope.response = "Passwords do not match. "
                $scope.password = "";
                $scope.confirmpassword = "";
                $scope.validlogin = 4;
            } else {
                $scope.validlogin = 0;
            }
        }
        if ($scope.validlogin == 1 || $scope.validlogin == 0) {
            $http.post("https://www.gracenoteapp.com/gracenote/ajax/updateProfile.php?username=" + $scope.user.username + "&newusername=" + $scope.username + "&password=" + $rootScope.MD5($scope.password) + "&name=" + $scope.name)
                .success(function(data){
                    //console.log("ProfileCtrl got logon" + $scope.username);
                    if (data == "1") {
                        $scope.response = "User profile updated. ";
                        $scope.validlogin = 11;
                        $scope.password = "";
                        $scope.confirmpassword = "";
                        createLocalStore();
                        getLocalStore();
                        //$scope.$apply();
                    } else {
                        $scope.response = "Email address already exists or nothing has changed. ";
                        $scope.password = "";
                        $scope.confirmpassword = "";
                        $scope.validlogin = 7;
                        //$scope.$apply();
                    }
                })
                .error(function (e) {
                    $scope.response = "error";
                    $scope.response = "error " + e.message;
                    $scope.validlogin = 61;
                    console.log("InitialViewCtrl Something went wrong with login. Error message: " + e.message)
                })
            ;
        }
    }
    
})

.controller('UpdateNoteCtrl', function($scope, $stateParams,  $http, $ionicHistory, $rootScope,
                                       $ionicLoading, $cordovaCamera) {
    //console.log("UpdateNoteCtrl");
    $scope.native = $rootScope.native;
    $scope.imgURI = null;

    //getLocalStore();
    function getLocalStore() {
        $scope.user = $rootScope.user;
        getNote();
    }
    
    var picture = document.getElementById('picture');
    picture.addEventListener('change', function(e) {
        $scope.loadPicture();
    });  
      
    $scope.loadPicture = function() {
      //console.log("startRead");
        var picture = document.getElementById('picture').files[0];
        //console.log("Name: " + picture.name + "\n" + "Last Modified Date :" + picture.lastModifiedDate);
        var reader = new FileReader();
        reader.onloadend = function() {
            var data = reader.result;
            //console.log("reader.result="+reader.result);
            $scope.imgURI = data;
            $scope.$apply();
            var data_index = data.indexOf('base64') + 7;
            //console.log("data_index="+data_index);
            $scope.note.picture = data.slice(data_index, data.length);
            //console.log("picture="+$scope.note.picture);
            //console.log("reader.result="+reader.result);
            var picnum = Number($scope.note.picnum) + 1;
            $scope.note.picnum = picnum.toString();
            $scope.note.picCamera = 0;
            $scope.note.picLibrary = 0;
            //console.log("picnum="+$scope.note.picnum);
            //console.log("picCamera="+$scope.note.picCamera);
            //console.log("picnLibrary="+$scope.note.picLibrary);
        }
        reader.readAsDataURL(picture);
    }        

    $scope.getPicture = function() {
        //console.log("UpdateNoteCtrl In getPicture");
        var options = {
            quality : 75, 
            destinationType : Camera.DestinationType.DATA_URL, 
            sourceType : Camera.PictureSourceType.PHOTOLIBRARY, 
            allowEdit : true,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 300,
            targetHeight: 300,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: true
        };

        $cordovaCamera.getPicture(options)
            .then( function(imageData){
                //console.log("UpdateNoteCtrl Got Picture");
                //console.log("UpdateNoteCtrl Got Picture=" + imageData);
                $scope.note.picture = imageData;
                $scope.imgURI = "data:image/jpeg;base64," + imageData;
                $scope.$apply();
                var picnum = Number($scope.note.picnum) + 1;
                $scope.note.picnum = picnum.toString();
                $scope.note.picLibrary = 1;
                $scope.note.picCamera = 0;
            })
            .error(function (e) {
                //console.log("UpdateNoteCtrl Something went wrong with getPicture. Error message: " + e.message)
            })
        ;
        
    }
    
    $scope.takePicture = function() {
        //console.log("UpdateNoteCtrl In takePicture");
        var options = {
          quality: 75,
          destinationType: Camera.DestinationType.DATA_URL,
          sourceType: Camera.PictureSourceType.CAMERA,
          encodingType: Camera.EncodingType.JPEG,
          allowEdit: true,
          targetWidth: 300,
          targetHeight: 300,
          popoverOptions: CameraPopoverOptions,
          saveToPhotoAlbum: true
        };

        $cordovaCamera.getPicture(options)
            .then( function(imageData){
                //console.log("UpdateNoteCtrl Took Picture");
                //console.log("UpdateNoteCtrl Took Picture=" + result);
                ///// $scope.picture = "data:image/jpeg;base64," + imageData;
                $scope.note.picture = imageData;
                $scope.imgURI = "data:image/jpeg;base64," + imageData;
                $scope.$apply();
                var picnum = Number($scope.note.picnum) + 1;
                $scope.note.picnum = picnum.toString();
                $scope.note.picCamera = 1;
                $scope.note.picLibrary = 0;
            })
            .error(function (e) {
                console.log("UpdateNoteCtrl Something went wrong with getPicture. Error message: " + e.message)
            })
        ;
    }

    $scope.unPublish = function(id){
        //console.log("UpdateNoteCtrl unPublish");
        $rootScope.showSpinner();
        $http.post("http://www.gracenoteapp.com/gracenote/ajax/unPublishNote.php?NoteID="+id)
            .success(function(data){
                $ionicLoading.hide();
                //console.log("UdateNoteCtrl unPublished=" + id);
                $rootScope.$broadcast('refreshFeed');
                $rootScope.$broadcast('refreshWall');
                $ionicHistory.goBack();
                $ionicHistory.goBack();
                //supersonic.ui.layers.popAll();
            })
        ;
    }

    function getNote() {
        $rootScope.showSpinner();
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/getNote.php?NoteID=" + $stateParams.noteid).success(function (data) {
            $ionicLoading.hide();
            $scope.note = data[0];
            if ($scope.note.title != null) $scope.note.title = $rootScope.unescapestr($scope.note.title);
            if ($scope.note.descr != null) $scope.note.descr = $rootScope.unescapestr($scope.note.descr);
        });
    };

    $scope.updateNote = function() {
        $rootScope.showSpinner();
        //console.log("UpdateNoteCtrl Updating a note");
        //console.log("UpdateNoteCtrl note.descr="+$rootScope.escapeHTML($scope.note.descr));
        //console.log("UpdateNoteCtrl note.title="+$scope.note.title);
        //console.log("UpdateNoteCtrl note.picnum="+$scope.note.picnum);
        //console.log("UpdateNoteCtrl user.id="+$scope.user.id);
        //console.log("UpdateNoteCtrl note.picture="+$scope.note.picture);

        var FormData = {
          'noteid' : $scope.note.id,
          'fid' : $scope.user.id,
          'title' : $rootScope.escapeHTML($scope.note.title),
          'descr' : $rootScope.escapeHTML($scope.note.descr),
          'picnum' : $scope.note.picnum,
          'picture' : $scope.note.picture
        };
        
        $http({
          method: 'POST',
          url: 'https://www.gracenoteapp.com/gracenote/ajax/updateNote.php',
          data: FormData,
          headers: {'Content-Type': 'application/x-www-form-urlencoded'},
        })
        .success(function(response) {
            $ionicLoading.hide();
            $scope.note.codeStatus = response.data;
            $rootScope.$broadcast('refreshWall');
            //console.log("sending broadcast refreshWall");
            $ionicHistory.goBack();
            $ionicHistory.goBack();
            //supersonic.ui.layers.popAll();
        })
        .error(function(response) {
            $ionicLoading.hide();
            $scope.note.codeStatus = response || "Request failed";
        });
    }

    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("UpdateNoteCtrl beforeEnter callback fired");
        $scope.tab = $rootScope.tab;
        getLocalStore();
    });
})

.controller('NewNoteCtrl', function($scope, $stateParams,  $http, $ionicHistory, $rootScope,
                                    $ionicLoading, $cordovaCamera) {
    //console.log("NewNoteCtrl");
    $scope.note = null;
    $scope.user = null;
    $scope.picture = "";
    $scope.picnum = 0;
    $scope.picCamera = 0;
    $scope.picLibrary = 0;
    $scope.title = "";
    $scope.descr = "";
    $scope.response = "";
    $scope.native = $rootScope.native;
    $scope.imgURI = null;

    //getLocalStore();
    function getLocalStore() {
        $scope.user = $rootScope.user;
    }
    
    var picture = document.getElementById('picture');
    picture.addEventListener('change', function(e) {
        $scope.loadPicture();
    });  
      
   
    $scope.loadPicture = function() {
      //console.log("startRead");
        var picture = document.getElementById('picture').files[0];
        //console.log("Name: " + picture.name + "\n" + "Last Modified Date :" + picture.lastModifiedDate);
        var reader = new FileReader();

        reader.onloadend = function() {
          var data = reader.result;
          //console.log("reader.result="+reader.result);
          $scope.imgURI = data;
          var data_index = data.indexOf('base64') + 7;
          //console.log("data_index="+data_index);
          $scope.picture = data.slice(data_index, data.length);
          $scope.$apply();
          //console.log("picture="+$scope.picture);
          //console.log("reader.result="+reader.result);
          $scope.picnum = 1;
          $scope.picLibrary = 0;
          $scope.picCamera = 0;
        }
        reader.readAsDataURL(picture);
    }        
   
    
    
    $scope.getPicture = function() {
            //console.log("NewNoteCtrl In getPicture");
            var options = {
                quality : 75, 
                destinationType : Camera.DestinationType.DATA_URL, 
                sourceType : Camera.PictureSourceType.PHOTOLIBRARY, 
                allowEdit : true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 300,
                targetHeight: 300,
                popoverOptions: CameraPopoverOptions,
                saveToPhotoAlbum: true
            };

            $cordovaCamera.getPicture(options)
                .then( function(imageData){
                    //console.log("NewNoteCtrl Got Picture=" + imageData);
                    $scope.picture = imageData;
                    $scope.imgURI = "data:image/jpeg;base64," + imageData;
                    $scope.picnum = 1;
                    $scope.picLibrary = 1;
                    $scope.picCamera = 0;
                })
                .error(function (e) {
                    //console.log("NewNoteCtrl Something went wrong with getPicture. Error message: " + e.message)
                })
            ;
        
    }
    
    $scope.takePicture = function() {
        //console.log("NewNoteCtrl In takePicture");
        var options = {
          quality: 75,
          destinationType: Camera.DestinationType.DATA_URL,
          sourceType: Camera.PictureSourceType.CAMERA,
          encodingType: Camera.EncodingType.JPEG,
          allowEdit: true,
          targetWidth: 300,
          targetHeight: 300,
          popoverOptions: CameraPopoverOptions,
          saveToPhotoAlbum: true
        };

        $cordovaCamera.getPicture(options)
            .then( function(imageData){
                //console.log("NewNoteCtrl Took Picture=" + result);
                $scope.picture = imageData;
                $scope.imgURI = "data:image/jpeg;base64," + imageData;
                $scope.picnum = 1;
                $scope.picCamera = 1;
                $scope.picLibrary = 0;
            })
            .error(function (e) {
                console.log("NewNoteCtrl Something went wrong with getPicture. Error message: " + e.message)
            })
        ;
    }

    $scope.insertNewNote = function() {
        
        //console.log("NewNoteCtrl Adding a new note");
        //console.log("NewNoteCtrl descr="+$scope.descr);
        //console.log("NewNoteCtrl title="+$scope.title);
        //console.log("NewNoteCtrl user.name="+$scope.user.name);
        //console.log("NewNoteCtrl user.id="+$scope.user.id);
        //console.log("NewNoteCtrl picture="+$scope.picture);
        //console.log("NewNoteCtrl picnum="+$scope.picnum);
        $rootScope.showSpinner();
        
        var FormData = {
          'name' : $scope.user.name,
          'fid' : $scope.user.id,
          'title' : $rootScope.escapeHTML($scope.title),
          'descr' : $rootScope.escapeHTML($scope.descr),
          'picnum' : $scope.picnum,
          'picture' : $scope.picture
        };
        //console.log("FormData=" + FormData);
        $http({
          method: 'POST',
          url: 'https://www.gracenoteapp.com/gracenote/ajax/insertNewNote.php',
          data: FormData,
          headers: {'Content-Type': 'application/x-www-form-urlencoded'},
        })
        .success(function(response) {
            $ionicLoading.hide();
            $scope.response = response;
            $rootScope.$broadcast('refreshFeed');
            $rootScope.$broadcast('refreshWall');
            $ionicHistory.goBack();
            //supersonic.ui.layers.pop();
        })
        .error(function(response) {
            $scope.response = response || "Request failed";
        });
    }

    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("NoteNoteCtrl beforeEnter callback fired");
        $scope.tab = $rootScope.tab;
        getLocalStore();
    });
})
    
.controller('LoginCtrl', function($scope, $stateParams, $http, $ionicHistory, $state, $rootScope, $ionicLoading) {
    //console.log("InitialViewCtrl");
    $scope.name = "";
    $scope.username = "";
    $scope.password = "";
    $scope.validlogin = 1;
    $scope.response = "";
    $scope.confirmpassword = "";
    $scope.gnuser = null;        
    $scope.lasteventid = "";
    $scope.agreement = "";
    ionic.Platform.ready(function(){
        $scope.device = ionic.Platform.device();
        $rootScope.native = ionic.Platform.isWebView();
    });    

    $rootScope.showSpinner = function() {
        return $ionicLoading.show({template: '<i class="ion-loading-a"></i><br><h3 style="color: #fff !important;stroke: #fff !important; fill: #fff !important">Loading...</h3>', delay: 100, duration: 5000});
    };
    $rootScope.lastfeednoteid = 0;


  
    getLocalStore();
    function getLocalStore() {
        if (localStorage.getItem('gnuser') !== null) {
            var gnuser = JSON.parse(localStorage.getItem('gnuser'));
            //console.log("LoginCtrl gnuser.id="+gnuser.id);
            //console.log("LoginCtrl gnuser.name="+gnuser.name);
            //console.log("LoginCtrl gnuser.username="+gnuser.username);
            //console.log("LoginCtrl gnuser.fid="+gnuser.fid);
            //console.log("LoginCtrl gnuser.lasteventid="+gnuser.lasteventid);   
            $scope.user = gnuser;
            //console.log("LoginCtrl **** scope.user.lasteventid="+$scope.user.lasteventid);   
            $scope.username = gnuser.username;
            $scope.name = gnuser.name;
            $scope.agreement = gnuser.agreement;
            if (gnuser.lasteventid == null || gnuser.lasteventid == "") {
                $scope.lasteventid = '0';
            } else {
                $scope.lasteventid = gnuser.lasteventid;
            }
            $scope.agreement = gnuser.agreement;
            //$scope.$apply();
        } else {
          console.log("LoginCtrl gnuser is null");
        }
    }

    function createLocalStore() {
        //$scope.lasteventid = 0;
        if ($scope.user != null) {
            //console.log("InitialViewCtrl setting local storage"+$scope.user.name);
            localStorage.removeItem("gnuser");
            //console.log("LoginCtrl localStorage id="+$scope.user.fid);
            //console.log("LoginCtrl localStorage name="+$scope.name);
            //console.log("LoginCtrl localStorage username="+$scope.username);
            //console.log("LoginCtrl localStorage fid="+$scope.user.fid);
            //console.log("LoginCtrl localStorage lasteventid="+$scope.lasteventid);
            localStorage.setItem('gnuser', JSON.stringify({
                id: $scope.user.fid,
                name: $scope.name,
                username: $scope.username,
                fid: $scope.user.fid,
                lasteventid: $scope.lasteventid,
                agreement: 'I agree'
            }));
            //console.log("after setting local storage");
        } else {
            //console.log("InitialViewCtrl nulling local storage");
            localStorage.setItem('gnuser', JSON.stringify({
                id: '',
                name: '',
                username: '',
                fid: '',
                lasteventid: ''
            }));
        }
   }

    $scope.Login = function(){
        //console.log("InitialViewCtrl login name=" + $scope.name + " username=" + $scope.username + " password=" + $scope.password + " confirmpassword=" + $scope.confirmpassword);
        //console.log("initial validlogin=="+ $scope.validlogin);
        $scope.validlogin = 1;
        $scope.response = "";
        
        if ($scope.name == "") {
            //console.log("You must enter your name");
            $scope.response = $scope.response + "You must enter your name. "
            $scope.validlogin = 5;
        }
        if ($scope.username == "" || $scope.username == null) {
            console.log("You must enter a valid email. email=" + $scope.username);
            $scope.response = $scope.response + "You must enter a valid email. "
            $scope.validlogin = 7;
        }
        if ($scope.password == "") {
            //console.log("You must enter a password");
            $scope.response = $scope.response + "You must enter a password. "
            $scope.validlogin = 6;
        }
        if ($scope.validlogin == 1 && $scope.confirmpassword != "") {
            if ($rootScope.MD5($scope.password) != $rootScope.MD5($scope.confirmpassword)) {
                //console.log("Your passwords do not match");
                $scope.response = $scope.response + "Passwords do not match. "
                $scope.validlogin = 4;
            } else {
                //console.log("Your passwords match");
                $scope.validlogin = 0;
            }
            $scope.confirmpassword = "";
        }
        if ($scope.validlogin == 1 || $scope.validlogin == 0) {
            //console.log("validlogin=" + $scope.validlogin);
            $rootScope.showSpinner();
            $http.post("https://www.gracenoteapp.com/gracenote/ajax/login.php?username=" + $scope.username + "&password=" + $rootScope.MD5($scope.password) + "&name=" + $scope.name + "&validlogin=" + $scope.validlogin)
                .success(function(data){
                    $ionicLoading.hide();
                    //console.log("LoginCtrl got logon" + $scope.username);
                    if ($scope.validlogin == 0 && data == "Invalid Username") {
                        //console.log("get invalid username data="+data);
                        $scope.response = "Email address already exists.";
                        $scope.password = "";
                        $scope.confirmpassword = "";
                        $scope.validlogin = 8;
                    } else {
                        //console.log("got an array username data="+data);
                        if (data == "") {
                            //console.log("no data returned");
                            $scope.response = $scope.response + "Username not found";
                            $scope.password = "";
                            $scope.validlogin = 2;
                            //$scope.$apply();
                            //console.log("Username not found");
                        } else {
                            //console.log("data[0]=" + data[0]);
                            $scope.user = data[0];
                            //$scope.$apply();
                            if ($rootScope.MD5($scope.password) == $scope.user.password) {
                                //valid login
                                //console.log("passwords match");

                                createLocalStore();

                                $rootScope.user = data[0];
                                $rootScope.agreement = "I agree";

                                $ionicHistory.nextViewOptions({
                                  disableAnimate: true,
                                  disableBack: true
                                });                                  

                                if ($scope.user.agreement == 1) {
                                    $state.go('tab.feed', {}, {location: "replace", reload: true});                                    
                                } else {
                                  //console.log("going to agreement");
                                    $state.go('agreement', {}, {location: "replace", reload: true});                                    
                                }

                            } else {
                                //console.log("passwords don't match");
                                //console.log("InitialViewCtrl password is incorrect" + $scope.user.password + "  MD5" + $rootScope.MD5($scope.password));
                                $scope.response = $scope.response + "Invalid Password";
                                $scope.password = "";
                                $scope.validlogin = 3;
                                //$scope.$apply();
                            }
                        }
                    }
                })
                .error(function (e) {
                    $ionicLoading.hide();
                    console.log("InitialViewCtrl Something went wrong with login. Error message: " + e.message)
                })
            ;
        }
    }
})

.controller('AmenCtrl', function($scope, $stateParams, $http, $ionicHistory, $state, $rootScope, $ionicLoading) {
    //console.log("AmenCtrl");
    $scope.query = "";
    $scope.user = null;
    $scope.amens = null;

    //getLocalStore();
    function getLocalStore() {
        $scope.user = $rootScope.user;
        getAmens();
    }


    $scope.doRefresh = function() {
        //console.log("AmenCtrl doRefresh");
        //location.reload();
        getLocalStore();
    }
    
    function getAmens(){
        //console.log("AmenCtrl get events for noteid=" + $stateParams.noteid);            
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/getAmens.php?NoteID=" + $stateParams.noteid)
            .success(function(data){
                //console.log("AmenCtrl got amens for noteid="+$stateParams.noteid);
                $scope.amens = data;
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            })
        ;
    }

    
    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("AmenCtrl beforeEnter callback fired");
        getLocalStore();
    });

})

.controller('FavCtrl', function($scope, $stateParams, $http, $ionicHistory, $state, $rootScope, $ionicLoading) {
    //console.log("FavCtrl");
    $scope.query = "";
    $scope.user = null;
    $scope.favs = null;

    //getLocalStore();
    function getLocalStore() {
        $scope.user = $rootScope.user;
        getFavs();
    }


    $scope.doRefresh = function() {
        //console.log("FavCtrl doRefresh");
        //location.reload();
        getLocalStore();
    }
    
    function getFavs(){
        //console.log("FavCtrl get events for noteid=" + $stateParams.noteid);            
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/getFavs.php?NoteID=" + $stateParams.noteid)
            .success(function(data){
                //console.log("FavCtrl got favs for noteid="+$stateParams.noteid);
                $scope.favs = data;
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            })
        ;
    }

    
    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("FavCtrl beforeEnter callback fired");
        getLocalStore();
    });

})

.controller('AgreementCtrl', function($scope, $stateParams, $http, $ionicHistory, $state, $rootScope, $ionicLoading) {
    //console.log("AgreementCtrl");
    $scope.user = $rootScope.user;

    $scope.updateAgreement = function() {
        //console.log("AgreementCtrl fid=" + $scope.user.fid);
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/updateAgreement.php?fid=" + $scope.user.fid )
          .success(function (data) {
              $state.go('tab.feed', {}, {location: "replace", reload: true});                                    
          })
        ;
    };
    
    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("AgreemtnCtrl beforeEnter callback fired");
    });

})

.controller('BadgeCtrl', function($scope, $http, $rootScope) {
    //console.log("BadgeCtrl");
    $scope.newevents = "";
    $scope.lasteventid = "";

    pollEvents();
    function pollEvents() {
        $scope.user = $rootScope.user;
        //console.log("BadgeCtrl ajax post scope.user.fid=" + $scope.user.fid + " lasteventid=" + $scope.user.lasteventid);
        $http.post("https://www.gracenoteapp.com/gracenote/ajax/pollEvents.php?fid=" + $scope.user.fid + "&lasteventid=" + $scope.user.lasteventid)
            .success(function(data){
                //console.log("back from post");
                if (data.length != 0) {
                    //console.log("BadgeCtrl pollEvents returned data=" + data[0].newevents);
                    if (Number(data[0].newevents) > 0) {
                      $scope.newevents = data[0].newevents;
                      $scope.user.lasteventid = data[0].lasteventid;
                    } else {
                      $scope.newevents = "";
                    }
                    //console.log("BadgeCtrl newevents=" + $scope.newevents);
                } else {
                    console.log("BadgeCtrl return zero records. Should always return a record.");
                }
            })
            .error(function (e) {
                console.log("BadgeCtrl Something went wrong with pollEvents. Error message: " + e.message)
            })
        ;
        setTimeout(pollEvents, 60000);
    };

    $scope.$on('$ionicView.beforeEnter', function(){
        //console.log("BadgeCtrl beforeEnter callback fired");
        $scope.newevents = "";
        $http.post("http://www.gracenoteapp.com/gracenote/ajax/updateLasteventid.php?fid="+$scope.user.fid + "&lasteventid=" + $scope.user.lasteventid)
            .success(function(data){
                //console.log("BadgeCtrl set lasteventid="+$scope.user.lasteventid);
            })
        ;
    });



    
})

.filter('mysubfilter', function() {
    return function(input) {
        //input = input || '';
        var newstr = input;
        if (input.length > 250) {
            var str = input.substr(0,250);
            var lastSpace = str.lastIndexOf(" ");
            return str.substr(0,lastSpace) + " ...";
        }
        return newstr;
    };
})
.filter('unescape', function() {
    return function(input) {
      if (input == null) {
        return "";
      }
        return input
          .replace(/&amp;amp;/g, '&')
          .replace(/&amp;/g, '&')
          .replace(/&lt;/g, '<')
          .replace(/&gt;/g, '>')
          .replace(/&quot;/g, '\"')
          .replace(/&#39;/g, '\''); // '&apos;' is not valid HTML 4
        return newstr;
    };
})

.filter('moment', [
    function () {
        return function (date, method) {
            var momented = moment(date).subtract(1, 'hours');
            return momented[method].apply(momented, Array.prototype.slice.call(arguments, 2));
        };
    }
])

.run(function($rootScope) {
    $rootScope.escapeHTML = function(unsafe_str) {
        return unsafe_str
          .replace(/&/g, '&amp;')
          .replace(/</g, '&lt;')
          .replace(/>/g, '&gt;')
          .replace(/\"/g, '&quot;')
          .replace(/\'/g, '&#39;'); // '&apos;' is not valid HTML 4
    }
    
    $rootScope.unescapestr = function(unsafe_str) {
        return unsafe_str
          .replace(/&amp;/g, '&')
          .replace(/&lt;/g, '<')
          .replace(/&gt;/g, '>')
          .replace(/&quot;/g, '\"')
          .replace(/&#39;/g, '\''); // '&apos;' is not valid HTML 4
    };


    $rootScope.noteRefresh = function() {
          $rootScope.feedRefresh = true;
          $rootScope.favRefresh = true;
          $rootScope.wallRefresh = true;
          $rootScope.userviewRefresh = true;
          $rootScope.searchusersRefresh = true;
          $rootScope.searchnotesRefresh = true;
    };

    $rootScope.MD5 = function (string) {
    
      /**
      *
      *  MD5 (Message-Digest Algorithm)
      *  http://www.webtoolkit.info/
      *
      **/
        function RotateLeft(lValue, iShiftBits) {
            return (lValue<<iShiftBits) | (lValue>>>(32-iShiftBits));
        }
    
        function AddUnsigned(lX,lY) {
            var lX4,lY4,lX8,lY8,lResult;
            lX8 = (lX & 0x80000000);
            lY8 = (lY & 0x80000000);
            lX4 = (lX & 0x40000000);
            lY4 = (lY & 0x40000000);
            lResult = (lX & 0x3FFFFFFF)+(lY & 0x3FFFFFFF);
            if (lX4 & lY4) {
                return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
            }
            if (lX4 | lY4) {
                if (lResult & 0x40000000) {
                    return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
                } else {
                    return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
                }
            } else {
                return (lResult ^ lX8 ^ lY8);
            }
        }
    
        function F(x,y,z) { return (x & y) | ((~x) & z); }
        function G(x,y,z) { return (x & z) | (y & (~z)); }
        function H(x,y,z) { return (x ^ y ^ z); }
        function I(x,y,z) { return (y ^ (x | (~z))); }
    
        function FF(a,b,c,d,x,s,ac) {
            a = AddUnsigned(a, AddUnsigned(AddUnsigned(F(b, c, d), x), ac));
            return AddUnsigned(RotateLeft(a, s), b);
        };
    
        function GG(a,b,c,d,x,s,ac) {
            a = AddUnsigned(a, AddUnsigned(AddUnsigned(G(b, c, d), x), ac));
            return AddUnsigned(RotateLeft(a, s), b);
        };
    
        function HH(a,b,c,d,x,s,ac) {
            a = AddUnsigned(a, AddUnsigned(AddUnsigned(H(b, c, d), x), ac));
            return AddUnsigned(RotateLeft(a, s), b);
        };
    
        function II(a,b,c,d,x,s,ac) {
            a = AddUnsigned(a, AddUnsigned(AddUnsigned(I(b, c, d), x), ac));
            return AddUnsigned(RotateLeft(a, s), b);
        };
    
        function ConvertToWordArray(string) {
            var lWordCount;
            var lMessageLength = string.length;
            var lNumberOfWords_temp1=lMessageLength + 8;
            var lNumberOfWords_temp2=(lNumberOfWords_temp1-(lNumberOfWords_temp1 % 64))/64;
            var lNumberOfWords = (lNumberOfWords_temp2+1)*16;
            var lWordArray=Array(lNumberOfWords-1);
            var lBytePosition = 0;
            var lByteCount = 0;
            while ( lByteCount < lMessageLength ) {
                lWordCount = (lByteCount-(lByteCount % 4))/4;
                lBytePosition = (lByteCount % 4)*8;
                lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount)<<lBytePosition));
                lByteCount++;
            }
            lWordCount = (lByteCount-(lByteCount % 4))/4;
            lBytePosition = (lByteCount % 4)*8;
            lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80<<lBytePosition);
            lWordArray[lNumberOfWords-2] = lMessageLength<<3;
            lWordArray[lNumberOfWords-1] = lMessageLength>>>29;
            return lWordArray;
        };
    
        function WordToHex(lValue) {
            var WordToHexValue="",WordToHexValue_temp="",lByte,lCount;
            for (lCount = 0;lCount<=3;lCount++) {
                lByte = (lValue>>>(lCount*8)) & 255;
                WordToHexValue_temp = "0" + lByte.toString(16);
                WordToHexValue = WordToHexValue + WordToHexValue_temp.substr(WordToHexValue_temp.length-2,2);
            }
            return WordToHexValue;
        };
    
        function Utf8Encode(string) {
            string = string.replace(/\r\n/g,"\n");
            var utftext = "";
    
            for (var n = 0; n < string.length; n++) {
    
                var c = string.charCodeAt(n);
    
                if (c < 128) {
                    utftext += String.fromCharCode(c);
                }
                else if((c > 127) && (c < 2048)) {
                    utftext += String.fromCharCode((c >> 6) | 192);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
                else {
                    utftext += String.fromCharCode((c >> 12) | 224);
                    utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
    
            }
    
            return utftext;
        };
    
        var x=Array();
        var k,AA,BB,CC,DD,a,b,c,d;
        var S11=7, S12=12, S13=17, S14=22;
        var S21=5, S22=9 , S23=14, S24=20;
        var S31=4, S32=11, S33=16, S34=23;
        var S41=6, S42=10, S43=15, S44=21;
    
        string = Utf8Encode(string);
    
        x = ConvertToWordArray(string);
    
        a = 0x67452301; b = 0xEFCDAB89; c = 0x98BADCFE; d = 0x10325476;
    
        for (k=0;k<x.length;k+=16) {
            AA=a; BB=b; CC=c; DD=d;
            a=FF(a,b,c,d,x[k+0], S11,0xD76AA478);
            d=FF(d,a,b,c,x[k+1], S12,0xE8C7B756);
            c=FF(c,d,a,b,x[k+2], S13,0x242070DB);
            b=FF(b,c,d,a,x[k+3], S14,0xC1BDCEEE);
            a=FF(a,b,c,d,x[k+4], S11,0xF57C0FAF);
            d=FF(d,a,b,c,x[k+5], S12,0x4787C62A);
            c=FF(c,d,a,b,x[k+6], S13,0xA8304613);
            b=FF(b,c,d,a,x[k+7], S14,0xFD469501);
            a=FF(a,b,c,d,x[k+8], S11,0x698098D8);
            d=FF(d,a,b,c,x[k+9], S12,0x8B44F7AF);
            c=FF(c,d,a,b,x[k+10],S13,0xFFFF5BB1);
            b=FF(b,c,d,a,x[k+11],S14,0x895CD7BE);
            a=FF(a,b,c,d,x[k+12],S11,0x6B901122);
            d=FF(d,a,b,c,x[k+13],S12,0xFD987193);
            c=FF(c,d,a,b,x[k+14],S13,0xA679438E);
            b=FF(b,c,d,a,x[k+15],S14,0x49B40821);
            a=GG(a,b,c,d,x[k+1], S21,0xF61E2562);
            d=GG(d,a,b,c,x[k+6], S22,0xC040B340);
            c=GG(c,d,a,b,x[k+11],S23,0x265E5A51);
            b=GG(b,c,d,a,x[k+0], S24,0xE9B6C7AA);
            a=GG(a,b,c,d,x[k+5], S21,0xD62F105D);
            d=GG(d,a,b,c,x[k+10],S22,0x2441453);
            c=GG(c,d,a,b,x[k+15],S23,0xD8A1E681);
            b=GG(b,c,d,a,x[k+4], S24,0xE7D3FBC8);
            a=GG(a,b,c,d,x[k+9], S21,0x21E1CDE6);
            d=GG(d,a,b,c,x[k+14],S22,0xC33707D6);
            c=GG(c,d,a,b,x[k+3], S23,0xF4D50D87);
            b=GG(b,c,d,a,x[k+8], S24,0x455A14ED);
            a=GG(a,b,c,d,x[k+13],S21,0xA9E3E905);
            d=GG(d,a,b,c,x[k+2], S22,0xFCEFA3F8);
            c=GG(c,d,a,b,x[k+7], S23,0x676F02D9);
            b=GG(b,c,d,a,x[k+12],S24,0x8D2A4C8A);
            a=HH(a,b,c,d,x[k+5], S31,0xFFFA3942);
            d=HH(d,a,b,c,x[k+8], S32,0x8771F681);
            c=HH(c,d,a,b,x[k+11],S33,0x6D9D6122);
            b=HH(b,c,d,a,x[k+14],S34,0xFDE5380C);
            a=HH(a,b,c,d,x[k+1], S31,0xA4BEEA44);
            d=HH(d,a,b,c,x[k+4], S32,0x4BDECFA9);
            c=HH(c,d,a,b,x[k+7], S33,0xF6BB4B60);
            b=HH(b,c,d,a,x[k+10],S34,0xBEBFBC70);
            a=HH(a,b,c,d,x[k+13],S31,0x289B7EC6);
            d=HH(d,a,b,c,x[k+0], S32,0xEAA127FA);
            c=HH(c,d,a,b,x[k+3], S33,0xD4EF3085);
            b=HH(b,c,d,a,x[k+6], S34,0x4881D05);
            a=HH(a,b,c,d,x[k+9], S31,0xD9D4D039);
            d=HH(d,a,b,c,x[k+12],S32,0xE6DB99E5);
            c=HH(c,d,a,b,x[k+15],S33,0x1FA27CF8);
            b=HH(b,c,d,a,x[k+2], S34,0xC4AC5665);
            a=II(a,b,c,d,x[k+0], S41,0xF4292244);
            d=II(d,a,b,c,x[k+7], S42,0x432AFF97);
            c=II(c,d,a,b,x[k+14],S43,0xAB9423A7);
            b=II(b,c,d,a,x[k+5], S44,0xFC93A039);
            a=II(a,b,c,d,x[k+12],S41,0x655B59C3);
            d=II(d,a,b,c,x[k+3], S42,0x8F0CCC92);
            c=II(c,d,a,b,x[k+10],S43,0xFFEFF47D);
            b=II(b,c,d,a,x[k+1], S44,0x85845DD1);
            a=II(a,b,c,d,x[k+8], S41,0x6FA87E4F);
            d=II(d,a,b,c,x[k+15],S42,0xFE2CE6E0);
            c=II(c,d,a,b,x[k+6], S43,0xA3014314);
            b=II(b,c,d,a,x[k+13],S44,0x4E0811A1);
            a=II(a,b,c,d,x[k+4], S41,0xF7537E82);
            d=II(d,a,b,c,x[k+11],S42,0xBD3AF235);
            c=II(c,d,a,b,x[k+2], S43,0x2AD7D2BB);
            b=II(b,c,d,a,x[k+9], S44,0xEB86D391);
            a=AddUnsigned(a,AA);
            b=AddUnsigned(b,BB);
            c=AddUnsigned(c,CC);
            d=AddUnsigned(d,DD);
        }
    
        var temp = WordToHex(a)+WordToHex(b)+WordToHex(c)+WordToHex(d);
    
        return temp.toLowerCase();
    }

});

