angular.module('gracenote.services', [])

.factory('Chats', function() {
  // Might use a resource here that returns a JSON array

  // Some fake testing data
  var chats = [{
    id: 0,
    name: 'Ben Sparrow',
    lastText: 'You on your way?',
    face: 'https://pbs.twimg.com/profile_images/514549811765211136/9SgAuHeY.png'
  }, {
    id: 1,
    name: 'Max Lynx',
    lastText: 'Hey, it\'s me',
    face: 'https://avatars3.githubusercontent.com/u/11214?v=3&s=460'
  }, {
    id: 2,
    name: 'Andrew Jostlin',
    lastText: 'Did you get the ice cream?',
    face: 'https://pbs.twimg.com/profile_images/491274378181488640/Tti0fFVJ.jpeg'
  }, {
    id: 3,
    name: 'Adam Bradleyson',
    lastText: 'I should buy a boat',
    face: 'https://pbs.twimg.com/profile_images/479090794058379264/84TKj_qa.jpeg'
  }, {
    id: 4,
    name: 'Perry Governor',
    lastText: 'Look at my mukluks!',
    face: 'https://pbs.twimg.com/profile_images/491995398135767040/ie2Z_V6e.jpeg'
  }];

  return {
    all: function() {
      return chats;
    },
    remove: function(chat) {
      chats.splice(chats.indexOf(chat), 1);
    },
    get: function(chatId) {
      for (var i = 0; i < chats.length; i++) {
        if (chats[i].id === parseInt(chatId)) {
          return chats[i];
        }
      }
      return null;
    }
  }
})

/**
 * A simple example service that returns some data.
 */
.factory('Friends', function() {
  // Might use a resource here that returns a JSON array

  // Some fake testing data
  var friends = [{
    id: 0,
    name: 'Ben Sparrow',
    notes: 'Enjoys drawing things',
    face: 'https://pbs.twimg.com/profile_images/514549811765211136/9SgAuHeY.png'
  }, {
    id: 1,
    name: 'Max Lynx',
    notes: 'Odd obsession with everything',
    face: 'https://avatars3.githubusercontent.com/u/11214?v=3&s=460'
  }, {
    id: 2,
    name: 'Andrew Jostlen',
    notes: 'Wears a sweet leather Jacket. I\'m a bit jealous',
    face: 'https://pbs.twimg.com/profile_images/491274378181488640/Tti0fFVJ.jpeg'
  }, {
    id: 3,
    name: 'Adam Bradleyson',
    notes: 'I think he needs to buy a boat',
    face: 'https://pbs.twimg.com/profile_images/479090794058379264/84TKj_qa.jpeg'
  }, {
    id: 4,
    name: 'Perry Governor',
    notes: 'Just the nicest guy',
    face: 'https://pbs.twimg.com/profile_images/491995398135767040/ie2Z_V6e.jpeg'
  }];


  return {
    all: function() {
      return friends;
    },
    get: function(friendId) {
      // Simple index lookup
      return friends[friendId];
    }
  }
})

.factory('userFac', function($http) {
  return {
    getUser: function(fid, ffid) {
      //console.log("getUser fid=" + fid + " ffid=" + ffid);
            return $http.post("https://www.gracenoteapp.com/gracenote/ajax/getUser.php?fid=" + fid + "&ffid=" + ffid);
          /*
                .success(function (data) {
                  console.log("data=" + JSON.stringify(data[0]));
                  return data[0];
            });
          */
    }
  }
})

.factory('noteFactory', function($rootScope, $http) {
    var baseURL = "https://www.gracenoteapp.com/gracenote/ajax/";
    var feednotes = [];
    var searchnotes = [];
    var favnotes = [];
    var wallnotes = [];
    var usernotes = [];
    
    return {
        insertNoteFavorite: function(noteid, fid, efid, name, descr) {
            //console.log("insertNoteFavorite noteid=" + noteid + " fid=" + fid);
            //console.log("insertNoteFavorite descr=" + descr);
            var promise = $http.post(baseURL + "insertNoteFavorite.php?NoteID=" + noteid + "&fid=" + fid
                                     + "&efid=" + efid + "&name=" + name + "&descr=" + descr)
                .success(function (data) {
                    for (var i = 0; i < feednotes.length; i++) {
                      if (feednotes[i].id == noteid) {
                          feednotes[i].favorite = 1;
                      }
                    }
                    for (var i = 0; i < favnotes.length; i++) {
                      if (favnotes[i].id == noteid) {
                          favnotes[i].favorite = 1;
                      }
                    }
            });
            return promise;
        },
        deleteNoteFavorite: function(noteid,fid) {
            //console.log("deleteNoteFavorite noteid=" + noteid + " fid=" + fid);
            var promise = $http.post(baseURL + "deleteNoteFavorite2.php?NoteID=" + noteid + "&fid=" + fid)
                .success(function (data) {
                    for (var i = 0; i < feednotes.length; i++) {
                      if (feednotes[i].id == noteid) {
                          feednotes[i].favorite = 0;
                      }
                    }
                    for (var i = 0; i < favnotes.length; i++) {
                      if (favnotes[i].id == noteid) {
                          favnotes[i].favorite = 0;
                      }
                    }
            });
            return promise;
        },
        insertNoteAmen: function(noteid, fid, efid, name, descr) {
            //console.log("insertNoteAmen noteid=" + noteid + " fid=" + fid);
            var promise = $http.post(baseURL + "insertNoteAmen.php?NoteID=" + noteid + "&fid=" + fid
                                     + "&efid=" + efid + "&name=" + name +
                                     "&descr=" + $rootScope.escapeHTML(descr).substring(0,30))
                .success(function (data) {
                
            });
            return promise;
        },
        deleteNoteAmen: function(noteid,fid) {
            //console.log("deleteNoteAmen noteid=" + noteid + " fid=" + fid);
            var promise = $http.post(baseURL + "deleteNoteAmen2.php?NoteID=" + noteid + "&fid=" + fid)
                .success(function (data) {
                
            });
            return promise;
        },
        insertComment: function(FormData) {
            //console.log("insertComment FormData=" + JSON.stringify(FormData));
            var promise = $http({
                method: 'POST',
                url: baseURL + 'insertComment.php',
                data: FormData,
                headers: {'Content-Type': 'application/x-www-form-urlencoded'},
                })
                .success(function (data) {
                  
                })
            ;    
            return promise;
        },
        reportObjectionable: function(noteid,fid,reason) {
            //console.log("reportObjectionable noteid=" + noteid + " fid=" + fid + " reason=" + reason);
            var promise = $http.post(baseURL + "updateObjectionable.php?NoteID=" + noteid + "&fid=" + fid + "&reason=" + reason)
                .success(function (data) {
                })
            ;    
            return promise;
        },
        getFeedNotes: function(fid,lastnoteid) {
            //console.log("getFeedNotes fid=" + fid + " lastnoteid=" + lastnoteid);
            var promise = $http.post(baseURL + "getFeedNotes3.php?fid=" + fid + "&lastnoteid=" + lastnoteid)
                .success(function (data) {
                    if (lastnoteid == 0) {
                        feednotes = data;
                    } else {
                        feednotes = feednotes.concat(data);
                    }
                })
            ;    
            return promise;
        },
        getFeedNotesCache: function() {
            //console.log("getting feed notes cache");
            return feednotes;
        },
        getFeedNote: function(noteid) {
            //console.log("getting note from cache");
            for (var i = 0; i < feednotes.length; i++) {
              if (feednotes[i].id == noteid) {
                return feednotes[i];
              }
            }
            return null;
        },
        getFeedComments: function(noteid) {
            var promise = $http.post(baseURL + "getComments.php?NoteID=" + noteid)
                .success(function (data) {
                    // update note with the current number of comments
                    for (var i = 0; i < feednotes.length; i++) {
                      if (feednotes[i].id == noteid) {
                          feednotes[i].comments = data.length;
                          break;
                      }
                    }
                })
            ;    
            return promise;
        },
        searchSearchNotes: function(fid,lastnoteid,searchstr) {
            //console.log("searchSearchNotes fid=" + fid + " lastnoteid=" + lastnoteid + " searchstr=" + searchstr);
            var promise = $http.post(baseURL + "searchNotes3.php?fid=" + fid +
                                     "&lastnoteid=" + lastnoteid + "&searchstr=" + searchstr)
                .success(function (data) {
                    if (lastnoteid == 0) {
                        searchnotes = data;
                    } else {
                        searchnotes = searchnotes.concat(data);
                    }
                })
            ;    
            return promise;
        },
        getSearchNotesCache: function() {
            //console.log("getting search notes cache");
            return searchnotes;
        },
        getSearchNote: function(noteid) {
            //console.log("getting note from cache");
            for (var i = 0; i < searchnotes.length; i++) {
              if (searchnotes[i].id == noteid) {
                return searchnotes[i];
              }
            }
            return null;
        },
        getSearchComments: function(noteid) {
            var promise = $http.post(baseURL + "getComments.php?NoteID=" + noteid)
                .success(function (data) {
                    // update note with the current number of comments
                    for (var i = 0; i < searchnotes.length; i++) {
                      if (searchnotes[i].id == noteid) {
                          searchnotes[i].comments = data.length;
                          break;
                      }
                    }
                })
            ;    
            return promise;
        },
        getFavoriteNotes: function(fid,lastnoteid) {
            //console.log("getFeedNotes fid=" + fid + " lastnoteid=" + lastnoteid);
            var promise = $http.post(baseURL + "getFavoriteNotes3.php?fid=" + fid + "&lastnoteid=" + lastnoteid)
                .success(function (data) {
                    if (lastnoteid == 0) {
                        favnotes = data;
                    } else {
                        favnotes = favnotes.concat(data);
                    }
                })
            ;    
            return promise;
        },
        getFavoriteNotesCache: function() {
            //console.log("getting favorite notes cache");
            return favnotes;
        },
        getFavoriteNote: function(noteid) {
            //console.log("getting note from cache");
            for (var i = 0; i < favnotes.length; i++) {
              if (favnotes[i].id == noteid) {
                return favnotes[i];
              }
            }
            return null;
        },
        getFavoriteComments: function(noteid) {
            var promise = $http.post(baseURL + "getComments.php?NoteID=" + noteid)
                .success(function (data) {
                    // update note with the current number of comments
                    for (var i = 0; i < favnotes.length; i++) {
                      if (favnotes[i].id == noteid) {
                          favnotes[i].comments = data.length;
                          break;
                      }
                    }
                })
            ;    
            return promise;
        },
        getWallNotes: function(fid,lastnoteid) {
            //console.log("getWallNotes fid=" + fid + " lastnoteid=" + lastnoteid);
            var promise = $http.post(baseURL + "getWallNotes3.php?fid=" + fid + "&lastnoteid=" + lastnoteid)
                .success(function (data) {
                    if (lastnoteid == 0) {
                        wallnotes = data;
                    } else {
                        wallnotes = wallnotes.concat(data);
                    }
                })
            ;    
            return promise;
        },
        getWallNotesCache: function() {
            //console.log("getting wall notes cache");
            return wallnotes;
        },
        getWallNote: function(noteid) {
            //console.log("getting note from cache wallnotes.length=" + wallnotes.length);
            for (var i = 0; i < wallnotes.length; i++) {
              if (wallnotes[i].id == noteid) {
                return wallnotes[i];
              }
            }
            return null;
        },
        getWallComments: function(noteid) {
            var promise = $http.post(baseURL + "getComments.php?NoteID=" + noteid)
                .success(function (data) {
                    // update note with the current number of comments
                    for (var i = 0; i < wallnotes.length; i++) {
                      if (wallnotes[i].id == noteid) {
                          wallnotes[i].comments = data.length;
                          break;
                      }
                    }
                })
            ;    
            return promise;
        },
        getUserNotes: function(fid,lastnoteid,myfid) {
            //console.log("getUserNotes fid=" + fid + " lastnoteid=" + lastnoteid + "&myfid=" + myfid);
            var promise = $http.post(baseURL + "getUserNotes3.php?fid=" + fid + "&lastnoteid="
                                     + lastnoteid + "&myfid=" + myfid)
                .success(function (data) {
                    if (lastnoteid == 0) {
                        usernotes = data;
                    } else {
                        usernotes = usernotes.concat(data);
                    }
                })
            ;    
            return promise;
        },
        getUserNotesCache: function() {
            //console.log("getting feed notes cache");
            return usernotes;
        },
        getUserNote: function(noteid) {
            //console.log("getting note from cache");
            for (var i = 0; i < usernotes.length; i++) {
              //console.log( usernotes[i].id + " = " + noteid);
              if (usernotes[i].id == noteid) {
                //console.log("note=" + JSON.stringify(usernotes[i]));
                return usernotes[i];
              }
            }
            return null;
        },
        getUserComments: function(noteid) {
            var promise = $http.post(baseURL + "getComments.php?NoteID=" + noteid)
                .success(function (data) {
                    // update note with the current number of comments
                    for (var i = 0; i < usernotes.length; i++) {
                      if (usernotes[i].id == noteid) {
                          usernotes[i].comments = data.length;
                          break;
                      }
                    }
                })
            ;    
            return promise;
        },
        getEventNote: function(noteid, fid) {
            var promise = $http.post(baseURL + "getNote.php?NoteID=" + noteid + "&fid=" + fid)
                .success(function (data) {
                  //console.log("note=" + JSON.stringify(data));
                })
            ;    
            return promise;
        },
        getEventComments: function(noteid) {
            var promise = $http.post(baseURL + "getComments.php?NoteID=" + noteid)
                .success(function (data) {
                  //console.log("comments=" + JSON.stringify(data));
                })
            ;    
            return promise;
        },
        getNote: function(noteid, fid) {
            var promise = $http.post(baseURL + "getNote.php?NoteID=" + noteid + "&fid=" + fid)
                .success(function (data) {
                  //console.log("note=" + JSON.stringify(data));
                })
            ;    
            return promise;
        },
        getComments: function(noteid) {
            var promise = $http.post(baseURL + "getComments.php?NoteID=" + noteid)
                .success(function (data) {
                  //console.log("comments=" + JSON.stringify(data));
                })
            ;    
            return promise;
        }
    }
})

.factory('userFactory', function($rootScope, $http) {
    var baseURL = "https://www.gracenoteapp.com/gracenote/ajax/";
    var users = [];
    return {
        hgetUsers: function(fid) {
            //console.log("getting users from server");
            var promise = $http.post(baseURL + "searchUsers.php?fid=" + fid)
                .success(function (data) {
                    users = data;
            });
            return promise;
        },
        getUsers: function() {
          //console.log("getting users from cache");
          return users;
        },
        hgetUser: function(fid, ffid) {
            var promise = $http.post(baseURL + "getUser.php?fid=" + fid + "&ffid=" + ffid)
                .success(function (data) {

            });
            return promise;
        },
        insertFollower: function(fid, fidname, ffid, ffidname, privacy) {
            //console.log("inserting follower");
            var promise = $http.post(baseURL + "insertFollower2.php?fid=" + fid + "&fidname=" + fidname
                                     + "&ffid=" + ffid + "&ffidname=" + ffidname + "&privacy=" + privacy)
                .success(function (data) {

            });
            return promise;
        },
        deleteFollower: function(fid, ffid) {
            //console.log("deleting follower");
            var promise = $http.post(baseURL + "deleteFollower.php?fid=" + fid + "&ffid=" + ffid)
                .success(function (data) {

            });
            return promise;
        },
        getFollowing: function(fid) {
            //console.log("get following from server");
            var promise = $http.post(baseURL + "getFollowing2.php?fid=" + fid)
                .success(function (data) {
                })
            ;    
            return promise;
        },
        getFollower: function(fid) {
            //console.log("get followers from server");
            var promise = $http.post(baseURL + "getFollower2.php?fid=" + fid)
                .success(function (data) {
                })
            ;    
            return promise;
        },
        getUsers: function() {
          //console.log("getting following from cache");
          return following;
        },
        unFollow: function(fid,ffid) {
            //console.log("unFollow fid=" + fid + " ffid=" + ffid);
            var promise = $http.post(baseURL + "deleteFollower.php?fid=" + fid + "&ffid=" + ffid)
                .success(function (data) {
                })
            ;    
            return promise;
        }
    }
})
;
